﻿Public Class SimpleRTB
    Inherits System.Windows.Forms.RichTextBox

    ' ===============================================================================================
    '  ENABLE DISABLE PAINT and DISABLE ZOOM with CTRL WHEEL
    ' ===============================================================================================

    Friend PaintEventEnabled As Boolean = True

    Private Const MK_CONTROL As Int32 = &H8
    Private Const WM_MOUSEWHEEL As Int32 = &H20A

    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        Const WM_PAINT As Int32 = &HF
        If m.Msg = WM_PAINT AndAlso Not PaintEventEnabled Then
            m.Result = IntPtr.Zero
        ElseIf m.Msg = WM_MOUSEWHEEL Then
            If (m.WParam.ToInt32 And MK_CONTROL) = MK_CONTROL Then
                m.WParam = IntPtr.Zero
                m.Result = IntPtr.Zero
            Else
                MyBase.WndProc(m)
            End If
        Else
            MyBase.WndProc(m)
        End If
    End Sub

    Private Sub Me_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' -------------------------------------------------- suppress RTB sounds
        RichTextBox_SuppressSounds(sender, e)
    End Sub

    ' ===============================================================================================
    '   SELECTION CHANGED
    ' ===============================================================================================
    Private Sub SimpleRTB_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SelectionChanged
        '
        ' --------------------------------------------------------------------- AUTO WORD SELECTION BUG CORRECTION 
        Me.AutoWordSelection = True
        Me.AutoWordSelection = False
        ' ---------------------------------------------------------------------
    End Sub


End Class
