﻿Public Class SoundPlayer

    ' =================================================================================================
    ' Play sounds  ( au, snd, mp3, wav, wmv, asf, wma, mpg, midi, rmi, vob, dat )
    ' =================================================================================================

    Private Declare Auto Function mciSendString Lib "winmm.dll" (ByVal lpstrCommand As String, _
                                                                 ByVal lpstrReturnString As System.Text.StringBuilder, _
                                                                 ByVal uReturnLength As Int32, _
                                                                 ByVal hwndCallback As Int32) As Int32

    Friend Sub PlayRepeat(ByVal FileName As String)
        Dim cmd As String = "open """ & FileName & """ alias MediaFile"
        mciSendString(cmd, Nothing, 0, 0)
        mciSendString("play MediaFile repeat", Nothing, 0, 0)
    End Sub

    Friend Sub Play(ByVal FileName As String, ByVal WaitAndClose As Boolean)
        mciSendString("close MediaFile", Nothing, 0, 0)
        Dim cmd As String = "open """ & FileName & """ alias MediaFile"
        mciSendString(cmd, Nothing, 0, 0)
        mciSendString("play MediaFile", Nothing, 0, 0)
        If WaitAndClose Then
            WaitEnabled = True
            Do
                Threading.Thread.Sleep(1)
            Loop Until GetStatus() <> "playing" Or Not WaitEnabled
            mciSendString("close MediaFile", Nothing, 0, 0)
        End If
    End Sub

    Friend Sub PlayWithSpeed(ByVal FileName As String, ByVal speed As Int32, ByVal WaitAndClose As Boolean) ' speed normal = 1000
        mciSendString("close MediaFile", Nothing, 0, 0)
        Dim cmd As String = "open """ & FileName & """ alias MediaFile"
        mciSendString(cmd, Nothing, 0, 0)
        mciSendString("set MediaFile speed " & speed, Nothing, 0, 0)
        mciSendString("play MediaFile", Nothing, 0, 0)
        If WaitAndClose Then
            WaitEnabled = True
            Do
                Threading.Thread.Sleep(1)
            Loop Until GetStatus() <> "playing" Or Not WaitEnabled
            mciSendString("close MediaFile", Nothing, 0, 0)
        End If
    End Sub

    Private WaitEnabled As Boolean
    Friend Sub StopWaiting()
        WaitEnabled = False
    End Sub

    Friend Sub PlayStop()
        mciSendString("stop MediaFile", Nothing, 0, 0)
        mciSendString("close MediaFile", Nothing, 0, 0)
    End Sub

    Friend Sub PlayPause()
        mciSendString("pause MediaFile", Nothing, 0, 0)
    End Sub

    Friend Sub PlayResume()
        ' ----------------------------------------------- MIDI not restarting with resume
        'mciSendString("resume MediaFile", Nothing, 0, IntPtr.Zero)
        ' ----------------------------------------------- workaround
        mciSendString("play MediaFile", Nothing, 0, 0)
    End Sub

    ' ---------------------- Returns : "stopped" "paused" "playing" "ready"
    Friend Function GetStatus() As String
        Dim s As System.Text.StringBuilder
        s = New System.Text.StringBuilder(128)
        mciSendString("status MediaFile mode", s, 128, 0)
        Return LCase(s.ToString)
    End Function


    ' =================================================================================================
    '  VOLUME AND BALANCE
    ' =================================================================================================
    Private mVolumeSpeed As Int32 = 100
    Private mVolume As Int32 = 100
    Private mBalance As Int32 = 0

    Private newVolume As Int32 = 100
    Private newBalance As Int32 = 0

    Property VolumeSpeed() As Int32
        Get
            Return mVolumeSpeed
        End Get
        Set(ByVal value As Int32)
            If value < 0 Then value = 0
            If value > 100 Then value = 100
            mVolumeSpeed = value
        End Set
    End Property

    Property Volume() As Int32
        Get
            Return mVolume
        End Get
        Set(ByVal value As Int32)
            If value < 0 Then value = 0
            If value > 100 Then value = 100
            If value < 100 Then
                ' -------------------------------- gradual
                ChangeVolumeGradually(value)
            Else
                ' -------------------------------- immediate
                mVolume = value
                SetVolumeAndBalance()
            End If
        End Set
    End Property

    Property Balance() As Int32
        Get
            Return mBalance
        End Get
        Set(ByVal value As Int32)
            If value < -100 Then value = -100
            If value > 100 Then value = 100
            If value < 100 Then
                ' -------------------------------- gradual
                ChangeBalanceGradually(value)
            Else
                ' -------------------------------- immediate
                mBalance = value
                SetVolumeAndBalance()
            End If
        End Set
    End Property

    Private Sub ChangeVolumeGradually(ByVal newVolume As Integer)
        If newVolume <> mVolume Then 
            For i As Integer = mVolume To newVolume Step Math.Sign(newVolume - mVolume) * mVolumeSpeed
                mVolume = Math.Max(Math.Min(i, 100), 0)
                SetVolumeAndBalance()
                Threading.Thread.Sleep(100)
            Next i
        End If
    End Sub

    Private Sub ChangeBalanceGradually(ByVal newBalance As Integer)
        If newBalance <> mBalance Then 
            For i As Integer = mBalance To newBalance Step Math.Sign(newBalance - mBalance) * mVolumeSpeed
                mBalance = Math.Max(Math.Min(i, 100), 0)
                SetVolumeAndBalance()
                Threading.Thread.Sleep(100)
            Next i
        End If
    End Sub

    Private Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As IntPtr, ByVal dwVolume As UInteger) As Integer
    Private Sub SetVolumeAndBalance()
        ' ----------------------------------------
        Dim scaledVolumeLeft As UInteger
        Dim scaledVolumeRight As UInteger
        ' ---------------------------------------- linear
        If mBalance < 0 Then
            ' Balance to left
            scaledVolumeLeft = CUInt((mVolume * &HFFFF) / 100) And &HFFFFUI
            scaledVolumeRight = CUInt(((mVolume * (100 + mBalance)) * &HFFFF) / 10000) And &HFFFFUI
        Else
            ' Balance to right or center
            scaledVolumeRight = CUInt((mVolume * &HFFFF) / 100) And &HFFFFUI
            scaledVolumeLeft = CUInt(((mVolume * (100 - mBalance)) * &HFFFF) / 10000) And &HFFFFUI
        End If

        ' ---------------------------------------- decibels
        'If mBalance < 0 Then
        '    ' Balance to left
        '    scaledVolumeLeft = CUInt((Math.Pow(10, mVolume / 20.0) * &HFFFF) / 10) And &HFFFFUI
        '    scaledVolumeRight = CUInt((Math.Pow(10, (mVolume + mBalance) / 20.0) * &HFFFF) / 10) And &HFFFFUI
        'Else
        '    ' Balance to right or center
        '    scaledVolumeRight = CUInt((Math.Pow(10, mVolume / 20.0) * &HFFFF) / 10) And &HFFFFUI
        '    scaledVolumeLeft = CUInt((Math.Pow(10, (mVolume - mBalance) / 20.0) * &HFFFF) / 10) And &HFFFFUI
        'End If

        Dim combinedVolume As UInt32 = scaledVolumeRight << 16 Or scaledVolumeLeft
        waveOutSetVolume(IntPtr.Zero, combinedVolume)
    End Sub

    ' ----------------------------------------------------------------------
    '  The following functions are not tested and probably not working
    ' ----------------------------------------------------------------------
    'Friend Sub SetVolume(ByVal vol As Int32)
    '    mciSendString("setaudio MediaFile volume to " & vol, Nothing, 0, 0)
    '    'mciSendString("setaudio MediaFile left volume to " & vol, Nothing, 0, IntPtr.Zero)
    '    'mciSendString("setaudio MediaFile right volume to " & vol, Nothing, 0, IntPtr.Zero)
    'End Sub

    'Friend Sub SetBassTreble(ByVal bass As Int32, ByVal treble As Int32)
    '    mciSendString("setaudio MediaFile bass to " & bass, Nothing, 0, 0)
    '    mciSendString("setaudio MediaFile treble to " & treble, Nothing, 0, 0)
    'End Sub

    'Friend Sub SetPosition(ByVal millisec As Int32)
    '    mciSendString("set MediaFile time format milliseconds", Nothing, 0, 0)
    '    mciSendString("set MediaFile position " + millisec.ToString, Nothing, 0, 0)
    'End Sub

    'Friend Sub PlayFromTo(ByVal startPos As Int32, ByVal endPos As Int32)
    '    mciSendString("play MediaFile from " + startPos.ToString + " to " + endPos.ToString, Nothing, 0, 0)
    'End Sub

End Class
