﻿
Imports System.Collections.Generic

Public Class Form1

    Friend myResizer As Resizer = New Resizer
    Friend StartupControlsRatio As SizeF
    Friend SplitterDistance As Int32

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
        ' ------------------------------------------- if the same EXE file is already running then close
        If Not KeyPressedNow(Keys.ShiftKey) Then
            If MyExecFileIsAlreadyRunning(Application.ExecutablePath) Then
                Beep()
                End
            End If
        End If
        '
        WMP_Control_Init()
        '
        ' -------------------------------------------
        EventsAreEnabled = False
        ShowWindowTitle()
        InitProgramIdentifiers()
        InitKeywords()
        Buttons_Create()
        SetInitialButtonNamesColorsAndPositions()
        ResetButtonIdentifiersAndSlots()
        '
        ' ------------------------------------------- resizer
        GBox_Controls.Height = Me.Height
        GBox_Controls.Width = Me.Width
        myResizer.Init(Me)
        myResizer.DisableFontResize(GBox_Controls)
        myResizer.DisableControlResizeAndFontResize(GBox_Fonts)
        myResizer.DisableChildProcessing(GBox_Fonts)
        myResizer.DisableControlResizeAndFontResize(GBox_Program)
        myResizer.DisableChildProcessing(GBox_Program)
        myResizer.DisableControlResizeAndFontResize(StatusStrip1)
        myResizer.DisableControlResizeAndFontResize(StatusLabel1)
        myResizer.DisableChildProcessing(StatusStrip1)
        myResizer.DisableControlResizeAndFontResize(chk_Suggestions)
        '
        ' -------------------------------------------
        Me.BackColor = Color_Form
        GBox_Controls.BackColor = Color_Panels
        GBox_Program.BackColor = Color_PanelEditing
        PreparePanelsForProgram()
        PictureBox1.Visible = False
        SplitContainer1.Panel2Collapsed = True
        WMP.SendToBack()
        Form_Debug.Show()
        Form_Debug.Hide()
        Load_INI()
        RTB_and_PrintTextBox_Init()
        UpdateScrollButton()
        ' -------------------------------------------
        Load_Program()
        ' ------------------------------------------- hide the form if the load program timeout has shown it
        Me.Opacity = 0
        Me.Hide()
        ' -------------------------------------------
        Form_Debug.chk_PauseButtonSlot_Update()
        Form_Debug.chk_SendToRecycleBin_Update()
        ApplyEditorProps()
        EventsAreEnabled = True
        ' -------------------------------------------
        If Running Then
            StartRunning(True, 0)
        Else
            StopRunning(False, False)
        End If
        ShowHideTextAndTools()
        SplitContainer1.SplitterDistance = SplitterDistance
        ToolTips_Init()
        '
        ' ------------------------------------------- resizer
        If StartupControlsRatio.Width <> 0 And _
           StartupControlsRatio.Height <> 0 Then
            myResizer.ResizeAllControls_FixedRatio(Me, StartupControlsRatio)
        End If
        ResizeControlAndProgramPanels()
        SetButtonsPositions()
        '
        ' ------------------------------------------- WMP init
        Me.Hide()
        Me.Show()
        WMP_Init()
        RTB.Focus()
        RTB.SelectionLength = 0
        '
        ' ------------------------------------------- ViewMode must be after the ResizeAllControls
        Me.ViewMode = MainForm_StartingViewMode
        SetViewMode()
        If ViewMode <> ViewModes.FullScreen Then
            ShowInTaskbar = False
            ShowInTaskbar = True
        End If
        '
        ' ------------------------------------------- WindowState must be:
        '                                              - after the ViewMode
        '                                              - after the ResizeAllControls to be working
        '                                              - after WMP_Init to fullscreen-video working 
        Me.WindowState = MainForm_StartingWindowState
        '
        ' ------------------------------------------- Show the load message and eventually scroll to the first error
        LodedProgramMessage()
        ' ------------------------------------------- Required to start with the selected Zoom
        ApplyEditorProps()
        ' ------------------------------------------- show all
        Refresh()
        Form_Debug.Refresh()
        Application.DoEvents()
        SetFormOpacity()
        Form_Debug.Opacity = 1

        '
        ' ------------------------------------------- start all
        SchedulerMaxPrecision()
        Timer100ms.Interval = 100
        Timer100ms.Start()
        Timer50ms.Interval = 50
        Timer50ms.Start()
        Timer20ms.Interval = 20
        Timer20ms.Start()
        TimerFast.Interval = 15
        TimerFast.Start()
        ' ------------------------------------------- TEST FONTS
        'OpenFontsPanel()
        ' -------------------------------------------
        RTB.Focus()

        RTB.History_Clear()
    End Sub

    Friend Sub ShowWindowTitle()
        Text = AppTitleAndVersion() + "  -  Program :  " + IO.Path.GetFileName(ProgramFile_PathAndName)
    End Sub

    Friend Sub ShowProgramTitle()
        ShowHideTextAndTools()
    End Sub

    ' ===================================================================================================
    '  WMP CONTROL INIT
    ' ===================================================================================================
    Friend WithEvents WMP As AxWMPLib.AxWindowsMediaPlayer

    Private Sub WMP_Control_Init()
        Try
            Me.WMP = New AxWMPLib.AxWindowsMediaPlayer
            Me.SplitContainer1.Panel1.SuspendLayout()
            Me.SplitContainer1.Panel2.SuspendLayout()
            Me.SplitContainer1.SuspendLayout()
            Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
            CType(Me.WMP, System.ComponentModel.ISupportInitialize).BeginInit()
            ' ----------------------------------------------------------------- SplitContainer1.Panel1
            Me.SplitContainer1.Panel1.Controls.Add(Me.WMP)
            ' ----------------------------------------------------------------- WMP
            Me.WMP.Enabled = True
            Me.WMP.Location = New System.Drawing.Point(30, 24)
            Me.WMP.Name = "WMP"
            Me.WMP.OcxState = CType(resources.GetObject("WMP.OcxState"), System.Windows.Forms.AxHost.State)
            Me.WMP.Size = New System.Drawing.Size(250, 110)
            Me.WMP.TabIndex = 7
            Me.WMP.Visible = False
            ' ----------------------------------------------------------------- Form1
            Me.SplitContainer1.Panel1.ResumeLayout(False)
            Me.SplitContainer1.Panel1.PerformLayout()
            Me.SplitContainer1.Panel2.ResumeLayout(False)
            Me.SplitContainer1.ResumeLayout(False)
            CType(Me.WMP, System.ComponentModel.ISupportInitialize).EndInit()
            ' ----------------------------------------------------------------- ERROR MESSAGE TESTER
            'Error 1
        Catch ex As Exception
            MessageBox.Show("Windows Media Player not installed." + vbCrLf + vbCrLf + _
                            "If you are running a ""Windows"" version ""N""" + vbCrLf + _
                            "then you should install the ""Media Feature Pack""", _
                            "Message from Automation", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End
        End Try
    End Sub

    ' ===================================================================================================
    '  SPLIT CONTAINER - Refresh controls while moving
    ' ===================================================================================================
    Private Sub SplitContainer1_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs) Handles SplitContainer1.MouseDown
        SplitContainer1.IsSplitterFixed = True
    End Sub
    Private Sub SplitContainer1_MouseUp(ByVal sender As Object, ByVal e As MouseEventArgs) Handles SplitContainer1.MouseUp
        SplitContainer1.IsSplitterFixed = False
    End Sub
    Private Sub SplitContainer1_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs) Handles SplitContainer1.MouseMove
        If e.Button = MouseButtons.Left Then
            If e.Y > 0 And e.Y < SplitContainer1.Height Then
                SplitContainer1.SplitterDistance = e.Y
                SplitContainer1.Refresh()
            End If
        End If
    End Sub

    Private Sub SplitContainer1_SplitterMoved(ByVal sender As System.Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved
        If Not EventsAreEnabled Then Return
        If Not GBox_Program.ClientRectangle.Contains(GBox_Program.PointToClient(Cursor.Position)) Then Return
        SplitterDistance = SplitContainer1.SplitterDistance
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        e.Cancel = False
        CloseAll()
    End Sub

    Private Sub StopRunningAndWaitTimeout()
        ' --------------------------------- execute the EventStop with 10 second timeout
        StopRunning(False, True)
        For i As Int32 = 1 To 1000
            Threading.Thread.Sleep(10)
            Application.DoEvents()
            If TerminateThread OrElse Not Running Then Exit For
        Next
    End Sub

    Private Sub CloseAll()
        ' --------------------------------- save all
        'SaveSlots()
        'SaveVars()
        SaveProgram_IfChanged()
        Save_INI()
        ' --------------------------------- StopRunning and with timeout
        StopRunningAndWaitTimeout()
        ' --------------------------------- stop timers
        Timer100ms.Stop()
        Timer50ms.Stop()
        Timer20ms.Stop()
        TimerFast.Stop()
        ' --------------------------------- stop thread
        ExecutionThread_Stop()
        ShedulerDefaultPrecision()
        COM_Close()
        If Not Debugger.IsAttached Then
            CloseAllOpenedProcesses()
        End If
        ' ---------------------------------
        EventsAreEnabled = False
        Form_Input.Close()
        Try
            WMP.URL = Nothing
        Catch
        End Try
        ' ---------------------------------
        TTS_CloseAll()
        'ShowTrayWnd()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        Form1_Location = Me.Location
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private OldWindowState As FormWindowState
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        '
        ' ------------------------------------------------------------------ 
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        ' ------------------------------------------------------------------ 
        LimitFormPosition(Me)
        ' ------------------------------------------------------------------ Ensure controls positions and dimensions
        EnsureControlsPositionsAndDimensions()
        ' ------------------------------------------------------------------ ViewMode = Maximized/Sizable
        If Me.WindowState <> OldWindowState Then
            OldWindowState = Me.WindowState
            Select Case Me.WindowState
                Case FormWindowState.Maximized
                    ViewMode = ViewModes.Maximized
                Case FormWindowState.Normal
                    ViewMode = ViewModes.Sizable
                    Me.FormBorderStyle = Windows.Forms.FormBorderStyle.Sizable
                    ' ------------------------------------------------------ correct the dimensions when returning from minimized
                    ResizeControlAndProgramPanels()
                    SetButtonsPositions()
            End Select
            RedrawRtbUnscrolled()
            Refresh()
        End If
        ' ------------------------------------------------------------------
        ShowHideTextAndTools()
        ' ------------------------------------------------------------------
        ResizeStatusLabel()
        ' ------------------------------------------------------------------
        EventsAreEnabled = True
        ' ------------------------------------------------------------------ Set Visible Buttons (after EventsAreEnabled)
        SetVisibleButtons()
    End Sub

    Friend Sub ResizeStatusLabel()
        If chk_Suggestions.Visible Then
            StatusLabel1.Width = StatusStrip1.Width - chk_Suggestions.Width - 28
        Else
            StatusLabel1.Width = StatusStrip1.Width - 22
        End If
    End Sub

    Private Sub EnsureControlsPositionsAndDimensions()
        ResizeControlAndProgramPanels()
        GBox_Program.Height = Me.ClientSize.Height - StatusStrip1.Height - 8
        GBox_Controls.Top = GBox_Program.Top
        GBox_Controls.Height = GBox_Program.Height
        StatusLabel1.Width = Me.ClientSize.Width - 25
    End Sub

    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        RTB.ScrollToLeft()
        RTB.Invalidate()
        ' ---------------------------------------------------- ViewMode and NormalSize
        If Me.WindowState = FormWindowState.Normal Then
            ' ------------------------------------------------ FORCED ViewMode = Sizable WHEN RESIZING
            If EventsAreEnabled Then
                ViewMode = ViewModes.Sizable  ' FORCE ViewMode = Sizable WHEN RESIZING
                NormalSizeWidth = Me.Width
                NormalSizeHeight = Me.Height
            End If
        End If
    End Sub

    Private Sub PrintTextBox_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles PrintTextBox.Resize
        PrintTextBox.SelectionStart = 0
        PrintTextBox.ScrollToCaret()
        PrintTextBox.SelectionStart = 99999
        PrintTextBox.ScrollToCaret()
        ' --------------------------------------------- PrintTextBox_ResizeHeightToIntegerLines (not working)
        'PrintTextBox_ResizeHeightToIntegerLines()
    End Sub

    'Private Sub PrintTextBox_ResizeHeightToIntegerLines()
    '    If SplitContainer1.Panel2.Height < 1 Then Return
    '    If PrintTextBox.Lines.Length < 1 Then Return
    '    Dim h As Int32
    '    h = TextRenderer.MeasureText(PrintTextBox.CreateGraphics, PrintTextBox.Text, PrintTextBox.Font).Height
    '    h \= PrintTextBox.Lines.Length
    '    h = 20
    '    Dim nlines As Int32 = CInt(Math.Floor(SplitContainer1.Panel2.Height / h))
    '    PrintTextBox.Height = nlines * PrintTextBox.Font.Height
    'End Sub

    Private Sub RTB_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTB.MouseLeave
        lbl_DebugText.Visible = False
    End Sub

    Private Sub RedrawRtbUnscrolled()
        ' ------- Force the RTB window to show all the text un-scrolled
        ' ------- otherwise some part of the text could be not visible
        Dim oldzoom As Single = RTB.ZoomFactor
        RTB.ZoomFactor = 0.1
        RTB.ZoomFactor = oldzoom
    End Sub

    Friend Sub SetStatusLabelFontProportional()
        StatusLabel1.Font = New Font("Arial", 11, FontStyle.Bold)
    End Sub

    Friend Sub SetStatusLabelFontFixed()
        StatusLabel1.Font = New Font("Lucida console", 13, FontStyle.Bold)
    End Sub

    ' =============================================================================================
    '  MenuStrip, ToolStrip and RichTextBox accepting the first click
    '  If the form is not focused and receives a WM_PARENTNOTIFY (528) message
    '  then the form is activated before to exec the message
    ' ---------------------------------------------------------------------------------------------
    '  In addition the "TopMost" brings the window on the top 
    ' =============================================================================================
    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
            Me.TopMost = True
            Me.TopMost = False
        End If
        MyBase.WndProc(m)
    End Sub

    ' -----------------------------------------------------------------------------------------------------
    '  SHOW and HIDE Text and TOOLS
    ' ----------------------------------------------------------------------------------------------------- 
    Private Sub ShowHideTextAndTools()
        ' --------------------------------------------------------------------- hide/show program text
        Dim GBoxProgramTextLength As Single
        Dim txt As String = "Program :  " + IO.Path.GetFileName(ProgramFile_PathAndName)
        GBoxProgramTextLength = TextRenderer.MeasureText(txt, GBox_Program.Font).Width
        If Running AndAlso GBoxProgramTextLength + 10 < GBox_Program.ClientSize.Width Then
            GBox_Program.Text = txt
        ElseIf GBoxProgramTextLength + 10 < chk_Comment.Left Then
            GBox_Program.Text = txt
        Else
            GBox_Program.Text = ""
        End If
        ' --------------------------------------------------------------------- hide/show tools
        If Running Then
            HideTools()
        Else
            chk_Comment.Visible = chk_Comment.Left > 10
            chk_Uncomment.Visible = chk_Uncomment.Left > 10
            chk_Undo.Visible = chk_Undo.Left > 10
            chk_Redo.Visible = chk_Redo.Left > 10
            chk_HistoryBack.Visible = chk_HistoryBack.Left > 10
            chk_HistoryForward.Visible = chk_HistoryForward.Left > 10
            chk_GoToNextOccurrence.Visible = chk_GoToNextOccurrence.Left > 10
            chk_GotoDeclaration.Visible = chk_GotoDeclaration.Left > 10
            chk_Debug.Visible = chk_Debug.Left > 10
            chk_Help.Visible = chk_Help.Left > 10
        End If
        ' --------------------------------------------------------------------- hide/show label_lines
        Label_Lines.Visible = Label_Lines.Left > 0
        ' --------------------------------------------------------------------- hide/show speed zoom opacity
        tkbar_Speed.Visible = tkbar_Speed.Right < Label_Lines.Left
        tkbar_Zoom.Visible = tkbar_Zoom.Right < Label_Lines.Left
        tkbar_Transparency.Visible = tkbar_Transparency.Right < Label_Lines.Left
        chk_ScrollEnabled.Visible = chk_ScrollEnabled.Right < Label_Lines.Left
    End Sub

    ' -----------------------------------------------------------------------------------------------------
    '  TOOLS
    ' -----------------------------------------------------------------------------------------------------
    Private Sub chk_Comment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Comment.Click
        RTB.CommentSelectedLines(True)
        RTB.Focus()
    End Sub
    Private Sub chk_Uncomment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Uncomment.Click
        RTB.CommentSelectedLines(False)
        RTB.Focus()
    End Sub
    Private Sub chk_Undo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_Undo.MouseDown
        AutorepeatStart("UNDO")
    End Sub
    Private Sub chk_Redo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_Redo.MouseDown
        AutorepeatStart("REDO")
    End Sub
    Private Sub chk_HistoryBack_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_HistoryBack.MouseDown
        AutorepeatStart("BACK")
    End Sub
    Private Sub chk_HistoryForward_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_HistoryForward.MouseDown
        AutorepeatStart("FORWARD")
    End Sub
    Private Sub chk_GotoNextWordOccurrence_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_GoToNextOccurrence.Click
        RTB.GoToNextOccurrence()
        RTB.Focus()
    End Sub
    Private Sub chk_GotoDeclaration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_GotoDeclaration.Click
        RTB.GoToDeclaration()
        RTB.Focus()
    End Sub
    Private Sub chk_Debug_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Debug.Click
        If Form_Debug.Visible Then
            Form_Debug.Hide()
        Else
            Form_Debug.Show()
        End If
    End Sub
    Private Sub chk_Help_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_Help.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            OpenHelpFile()
        Else
            LocateHelpFile()
        End If
    End Sub

    Private Sub ShowTools()
        If Running Then Return
        chk_Comment.Visible = True
        chk_Uncomment.Visible = True
        chk_Undo.Visible = True
        chk_Redo.Visible = True
        chk_HistoryBack.Visible = True
        chk_HistoryForward.Visible = True
        chk_GoToNextOccurrence.Visible = True
        chk_GotoDeclaration.Visible = True
        chk_Debug.Visible = True
        chk_Help.Visible = True
    End Sub
    Private Sub HideTools()
        chk_Comment.Visible = False
        chk_Uncomment.Visible = False
        chk_Undo.Visible = False
        chk_Redo.Visible = False
        chk_HistoryBack.Visible = False
        chk_HistoryForward.Visible = False
        chk_GoToNextOccurrence.Visible = False
        chk_GotoDeclaration.Visible = False
        chk_Debug.Visible = False
        chk_Help.Visible = False
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  CONTEXTUAL MENU - EDITOR
    ' -----------------------------------------------------------------------------------------------------
    Private RTB_MousePos As Point
    Private Sub MenuStrip_Edit_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MenuStrip_Edit.Opening
        RTB_MousePos = RTB.PointToClient(MousePosition)
        MenuStrip_Edit.Show(RTB, RTB_MousePos.X + 100, RTB_MousePos.Y + 20)
    End Sub
    Private Sub MenuStrip_Edit_Debug_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Debug.Click
        Form_Debug.Show()
    End Sub
    Private Sub MenuStrip_Edit_ToggleBreakpoint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_ToggleBreakpoint.Click
        RTB.ToggleBreakPoint(RTB_MousePos)
    End Sub
    Private Sub MenuStrip_Edit_DeleteAllBreakpoints_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_DeleteAllBreakpoints.Click
        RTB.DeleteAllBreakPoints()
    End Sub
    Private Sub MenuStrip_Edit_Comment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Comment.Click
        RTB.CommentSelectedLines(True)
    End Sub
    Private Sub MenuStrip_Edit_Uncomment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Uncomment.Click
        RTB.CommentSelectedLines(False)
    End Sub
    Private Sub MenuStrip_Edit_GoBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoBack.Click
        RTB.History_Back()
        RTB.Focus()
    End Sub
    Private Sub MenuStrip_Edit_GoForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoForward.Click
        RTB.History_Forward()
        RTB.Focus()
    End Sub
    Private Sub MenuStrip_Edit_GotoNextWordOccurrence_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoToNextOccurrence.Click
        RTB.GoToNextOccurrence()
    End Sub
    Private Sub MenuStrip_Edit_GotoDeclaration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoToDeclaration.Click
        RTB.GoToDeclaration()
    End Sub
    Private Sub MenuStrip_Edit_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Cut.Click
        RTB.ExecCut()
    End Sub
    Private Sub MenuStrip_Edit_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Copy.Click
        RTB.ExecCopy()
    End Sub
    Private Sub MenuStrip_Edit_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Paste.Click
        RTB.ExecPaste()
    End Sub
    Private Sub MenuStrip_Edit_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Delete.Click
        RTB.ExecDelete()
    End Sub
    Private Sub MenuStrip_Edit_SelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_SelectAll.Click
        RTB.SelectAll()
    End Sub
    Private Sub MenuStrip_Edit_Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Find.Click
        RTB.Editor_Find()
    End Sub
    Private Sub MenuStrip_Edit_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Replace.Click
        RTB.Editor_FindReplace()
    End Sub
    Private Sub MenuStrip_Edit_ReplaceTabsWithSpaces_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_ReplaceTabsWithSpaces.Click
        RTB.ExecReplaceTabsWithSpaces()
    End Sub
    Private Sub MenuStrip_Edit_ReplaceSpacesWithTabs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_ReplaceSpacesWithTabs.Click
        RTB.ExecReplaceSpacesWithTabs()
    End Sub
    Private Sub MenuStrip_Edit_ChangeFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_ChangeFont.Click
        OpenFontsPanel()
    End Sub


    ' ===============================================================================================================
    '  FONTS
    ' ===============================================================================================================
    Friend FontName As String = ""

    Private Sub OpenFontsPanel()
        ' ------------------------------------------------------------------------------
        GBox_Fonts.Parent = Me
        GBox_Fonts.Location = GBox_Controls.Location
        GBox_Fonts.Size = GBox_Controls.Size
        GBox_Fonts.BringToFront()
        GBox_Fonts.Visible = True
        ' ------------------------------------------------------------------------------
        Dim sa() As String = GetInstalledFontNames_Monospaced()
        ListBox_Fonts.Items.Clear()
        ListBox_Fonts.Items.AddRange(sa)
        'ListBox_Fonts.Items.Add("Arial")
        ' ------------------------------------- CHINESE FONTS 'FangSong KaiTi HeiTi YaHei SimSun SimHei LiSu YouYuan
        ListBox_Fonts.Items.Add("FangSong")
        ListBox_Fonts.Items.Add("KaiTi")
        'ListBox_Fonts.Items.Add("HeiTi") ' not installed
        'ListBox_Fonts.Items.Add("YaHei") ' not installed
        ListBox_Fonts.Items.Add("SimSun")
        ListBox_Fonts.Items.Add("SimHei")
        'ListBox_Fonts.Items.Add("LiSu") ' not installed
        'ListBox_Fonts.Items.Add("YouYuan") ' not installed
        ' ------------------------------------------------------------------------------
        EventsAreEnabled = False
        Dim i As Int32 = ListBox_Fonts.Items.IndexOf(FontName)
        If i >= 0 Then ListBox_Fonts.SelectedItem = ListBox_Fonts.Items(i)
        EventsAreEnabled = True
        ' ------------------------------------------------------------------------------
        ListBox_Fonts.Focus()
    End Sub

    Private Sub ListBox_Fonts_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ListBox_Fonts.KeyUp
        ListBox_Fonts.Focus()
    End Sub

    Private Sub ListBox_Fonts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox_Fonts.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        SetNewFont(ListBox_Fonts.SelectedItem.ToString)
        ListBox_Fonts.Focus()
    End Sub

    Friend Sub SetNewFont(ByVal fname As String)
        FontName = fname
        RTB_and_PrintTextBox_Init()
        If RTB_Lines.Length < 200 Then RTB.ColorAllLines()
        Save_INI()
    End Sub

    Private Sub chk_OpenFontsFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_OpenFontsFolder.Click
        OpenFontsFolder()
    End Sub
    Private Sub chk_InstallNewFonts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_InstallNewFonts.Click
        InstallNewFonts()
    End Sub
    Private Sub chk_CloseFontPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_CloseFontPanel.Click
        GBox_Fonts.Visible = False
        If RTB_Lines.Length >= 200 Then RTB.ColorAllLines()
    End Sub


    ' =============================================================================================
    '  APPLICATION CONTROLS
    ' ============================================================================================= 
    Private Sub chk_ControlsBack_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_ControlsBack.MouseDown
        AutorepeatStart("BACK")
    End Sub
    Private Sub chk_ControlsForward_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_ControlsForward.MouseDown
        AutorepeatStart("FORWARD")
    End Sub
    Private Sub chk_ControlsGoToNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ControlsGoToNext.Click
        RTB.GoToNextOccurrence()
        RTB.Focus()
        chk_ControlsGoToNext.Checked = False
    End Sub
    Private Sub chk_ControlsGoToDeclaration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsGoToDeclaration.Click
        RTB.GoToDeclaration()
        RTB.Focus()
        chk_ControlsGoToDeclaration.Checked = False
    End Sub
    Private Sub chk_ControlsUndo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_ControlsUndo.MouseDown
        AutorepeatStart("UNDO")
    End Sub
    Private Sub chk_ControlsRedo_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_ControlsRedo.MouseDown
        AutorepeatStart("REDO")
    End Sub

    Private Sub chk_ControlsLoad_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_ControlsLoad.MouseDown
        chk_ControlsLoad.Checked = True
        ' -------------------------------------------------------- save old values
        Dim oldProgram As String = ProgramFile_PathAndName
        Dim sd As SyntaxRichTextBox.ScrollData
        RTB.SaveSelectionAndScroll(sd)
        ' -------------------------------------------------------- load
        ErrorsCounter = 0
        WarningsCounter = 0
        If e.Button = Windows.Forms.MouseButtons.Left Then
            LoadProgramDialog()
        Else
            Load_Program(ProgramFile_PathAndName)
        End If
        ' -------------------------------------------------------- restore scroll
        If ErrorsCounter = 0 And WarningsCounter = 0 Then
            If ProgramFile_PathAndName = oldProgram Then
                RTB.RestoreSelectionAndScroll(sd)
            End If
        End If
        ' -------------------------------------------------------- ensure "loaded" message after restore scroll
        LodedProgramMessage()
        RTB.ShowLinesCount()
        ' --------------------------------------------------------
        RTB.Focus()
        chk_ControlsLoad.Checked = False
    End Sub
    Private Sub chk_ControlsSave_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_ControlsSave.MouseDown
        chk_ControlsSave.Checked = True
        If e.Button = Windows.Forms.MouseButtons.Left Then
            SaveProgramDialog()
        Else
            Save_Program(ProgramFile_PathAndName)
        End If
        RTB.Focus()
        chk_ControlsSave.Checked = False
    End Sub

    Private Sub chk_ControlsRun_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_ControlsRun.Click
        If chk_ControlsRun.Checked Then
            chk_ControlsRun.Enabled = False
            chk_ControlsRun.Checked = False
            ' --------------------------------- StopRunning and with timeout
            StopRunningAndWaitTimeout()
            '
            TerminateThread = True
            StopRunning(False, False)
            chk_ControlsRun.Enabled = True
        Else
            StartRunning(True, 0)
        End If
    End Sub

    Private Sub txt_WebBrowserURL_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txt_WebBrowserURL.KeyDown
        If e.KeyCode = Keys.Return Then
            e.SuppressKeyPress = True
            e.Handled = True
            Dim url As String = txt_WebBrowserURL.Text
            If Not url.StartsWith("http") Then url = "http://" + url
            WB.Navigate(url)
        End If
    End Sub

    Private WB_zoom As Int32 = 100
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        '
        If Running Then
            ' ------------------------------------------------------------- STOP RUNNING with SHIFT-ESC and ALT-E
            If e.KeyCode = Keys.Escape AndAlso _
               My.Computer.Keyboard.ShiftKeyDown Then
                If ViewMode = ViewModes.FullScreen Then SetViewMode_ThreadSafe(ViewModes.Maximized)
                StopRunning()
            End If
            If e.KeyCode = Keys.E AndAlso _
               My.Computer.Keyboard.AltKeyDown Then
                If ViewMode = ViewModes.FullScreen Then SetViewMode_ThreadSafe(ViewModes.Maximized)
                StopRunning()
            End If
            ' ------------------------------------------------------------- STOP RUNNING with F8
            If e.KeyCode = Keys.F8 AndAlso Not Form_Debug.Visible Then
                StopRunning()
            End If
            ' ------------------------------------------------------------- if WEB navigating then KEYS are disabled
            If PanelMode = PanelModes.Web Then
                Return
            End If
            ' ------------------------------------------------------------- suppress keys for pageup/down while running
            If Not PrintTextBox.Visible Or _
               e.KeyCode = Keys.PageUp Or _
               e.KeyCode = Keys.PageDown Or _
               e.KeyCode = Keys.Prior Or _
               e.KeyCode = Keys.Next Then
                e.SuppressKeyPress = True
                e.Handled = True
            End If
        Else
            ' ------------------------------------------------------------- STEP if debugging with F5 
            If e.KeyCode = Keys.F5 Then
                If Debugging Then
                    Form_Debug.DoSingleStep()
                End If
            End If
            ' ------------------------------------------------------------- RUN with F8 or ALT+R 
            If e.KeyCode = Keys.F8 OrElse _
                (e.KeyCode = Keys.R AndAlso My.Computer.Keyboard.AltKeyDown) Then
                If Form_Debug.Visible Then
                    Form_Debug.chk_Run.Checked = Not Form_Debug.chk_Run.Checked
                Else
                    StartRunning(True, 0)
                End If
            End If
        End If
        ' ------------------------------------------------------------- Resize controls with CTRL + SHIFT + ARROWS
        If My.Computer.Keyboard.CtrlKeyDown AndAlso _
           My.Computer.Keyboard.ShiftKeyDown Then
            RTB_Lines = RTB.Lines
            e.SuppressKeyPress = True
            e.Handled = True
            Select Case e.KeyCode
                Case Keys.Left : ResizeControlsWithControlShift_By(-10, 0) : Me.Refresh()
                Case Keys.Right : ResizeControlsWithControlShift_By(+10, 0) : Me.Refresh()
                Case Keys.Up : ResizeControlsWithControlShift_By(0, -5) : Me.Refresh()
                Case Keys.Down : ResizeControlsWithControlShift_By(0, +5) : Me.Refresh()
            End Select
        End If
    End Sub

    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        If PrintTextBox.Focused Then Return
        KeyEventsStackIndex = 99999
        ' ------------------------------------------------------ reinitialize the autorepeat status
        PollKeysRepeatStatus = 0
    End Sub



    ' --------------------------------------------------------------
    '  Sometimes the Arrow Keys does not generate the KeyDown event
    '  this happens mainly with KeyPreview = True
    '  when some control does not transfer the event properly
    ' --------------------------------------------------------------
    '  In the CmdKeys are included also SHIFT, CTRL and ALT
    '  so you could add them in the IF to ensure the KeyDown
    ' --------------------------------------------------------------
    Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal keydata As Keys) As Boolean
        If Running Then
            ' ----------------------------------------------------- remove the SHIFT KEY
            keydata = keydata And Not Keys.Shift
            ' ----------------------------------------------------- PrintTextBox accepting Arrows and CTRL-A/X/C
            If PrintTextBox.Focused Then
                ' -------------------------------------------------------- NOT EDITABLE
                'If keydata = Keys.Right Or keydata = Keys.Left Or _
                '   keydata = Keys.Up Or keydata = Keys.Down Or _
                '   keydata = Keys.Back Or keydata = Keys.Cancel Or _
                '   keydata = Keys.PageUp Or keydata = Keys.PageDown Or _
                '   keydata = (Keys.Control Or Keys.A) Or _
                '   keydata = (Keys.Control Or Keys.X) Or _
                '   keydata = (Keys.Control Or Keys.C) Then
                '    Return False
                'Else
                '    Return True
                'End If
                ' -------------------------------------------------------- EDITABLE
                Return False
            End If
            ' ----------------------------------------------------- 
            If keydata = Keys.Right Or keydata = Keys.Left Or _
               keydata = Keys.Up Or keydata = Keys.Down Then
                OnKeyDown(New KeyEventArgs(keydata))
                ProcessCmdKey = True
            Else
                ProcessCmdKey = MyBase.ProcessCmdKey(msg, keydata)
            End If
        Else
            ProcessCmdKey = MyBase.ProcessCmdKey(msg, keydata)
        End If
    End Function


    ' =============================================================================================
    '  SELECT STATUS BAR KEYWORDS WITH MOUSE
    ' =============================================================================================
    Private Sub StatusLabel1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles StatusLabel1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            '
            ' ------------------------------------------------------------------------- SELECT KEYWORDS
            Dim s As String = GetClickedWord(StatusLabel1, e.Location)
            s = s.Replace("""", "")
            s = s.Replace(",", "")
            s = s.Replace(".", "")
            If s = "" Then Return
            Select Case s.ToLower
                Case "eventstop", "eventtimer", "flashing", "yellow", "blue", "red"
                    ' ----------------------------------------------------------------- add a space if needed
                    Dim s2 As String = RTB_Lines(RTB.GetFirstSelectedLine)
                    If s2.ToLower.EndsWith("color") Then
                        RTB.AddFinalSpace_ToRow()
                    End If
                    ' ----------------------------------------------------------------- complete keyword
                    RTB.CompleteKeyword_MouseSelected(s)
                Case Else
                    ' ----------------------------------------------------------------- select normal keywords
                    If StatusLabel1.Text.ToLower.StartsWith("keywords:") Then
                        If s <> "" And s.ToLower <> "keywords:" Then
                            RTB.CompleteKeyword_MouseSelected(s)
                        End If
                    End If
                    ' ----------------------------------------------------------------- select suggestion keywords
                    If StatusLabel1.Text.ToLower.Contains("suggestions:") Then
                        RTB.CompleteKeyword_MouseSelected(s)
                    End If
            End Select
        Else
            '
        End If
    End Sub

    Private Sub chk_Suggestions_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_Suggestions.Click
        Select Case RTB.SuggestionsButtonType
            Case "Errors"
                ' ----------------------------------------------------------------- Select the next error/warning line
                RTB.SelectNextErrorWarningLine()
            Case "Colors"
                ' ----------------------------------------------------------------- add a space if needed
                Dim s As String = RTB_Lines(RTB.GetFirstSelectedLine)
                If s.ToLower.EndsWith("color") Then
                    RTB.AddFinalSpace_ToRow()
                End If
                ' ----------------------------------------------------------------- open the color selector
                Form_Suggestions.Height = 650
                Form_Suggestions.Text = "Theremino Automation - Color Selector"
                Form_Suggestions.StartPosition = FormStartPosition.CenterScreen
                Form_Suggestions.ShowDialog()
        End Select
    End Sub


    ' =============================================================================================
    '  RICH TEXT BOX EDITOR
    ' =============================================================================================
    Private Color_Form As Color = Color.FromArgb(220, 220, 240)
    Private Color_Panels As Color = Color.FromArgb(240, 240, 240)
    Private Color_PanelEditing As Color = Color.FromArgb(240, 220, 180)
    Private Color_BackEditing As Color = Color.FromArgb(255, 250, 240)
    Private Color_BackRunning As Color = Color.FromArgb(220, 225, 220) '210, 210, 210)  '230, 230, 230) 
    Friend Color_PanelRunning As Color = Color.FromArgb(190, 220, 170) '210, 240, 190) 

    Friend Sub RTB_and_PrintTextBox_Init()
        ' ---------------------------------- do not fire textchanged events
        EventsAreEnabled = False
        '
        ' T--------------------------------- If not chinese fonts then ensure monospaced
        If Not "FangSong KaiTi HeiTi YaHei SimSun SimHei LiSu YouYuan".Contains(FontName) Then
            FontName = EnsureFontMonospaced(FontName)
        End If
        '
        With RTB
            ' ----------------------------------------------- ensure a complete font initialization
            .Font = New Font("Arial", 8)
            ' This option allows to use Chinese and Japanese chars mixed with Latin chars
            ' otherwise the font is changed to "Segoe UI Symbol" after displaying oriental chars 
            .LanguageOption = RichTextBoxLanguageOptions.DualFont
            ' The font-size determines the number of spaces for each TAB
            ' with font-size 15 each TAB is similar to 4 spaces
            .Font = New Font(FontName, 15, FontStyle.Regular)
            ' ------------------------------------------------------------------------------------
            .AcceptsTab = True
            .DetectUrls = False
            .WordWrap = False
            .HideSelection = False
        End With
        With PrintTextBox
            ' ----------------------------------------------- ensure a complete font initialization
            .Font = New Font("Arial", 8)
            .LanguageOption = RichTextBoxLanguageOptions.DualFont
            .Font = New Font(FontName, 15, FontStyle.Regular)
            ' -------------------------------------------------------------------------------------
            .ReadOnly = False
            .AcceptsTab = True
            .DetectUrls = False
            .WordWrap = True
            .HideSelection = False
            .BackColor = Color.FromArgb(255, 255, 220)
        End With
        EventsAreEnabled = True
    End Sub

    Private Sub TrackBars_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles tkbar_Speed.MouseLeave, _
                                                                                                  tkbar_Zoom.MouseLeave, _
                                                                                                  tkbar_Transparency.MouseLeave
        If Form_FindReplace.Visible Then
            Form_FindReplace.Focus()
        ElseIf Form_Input.Visible Then
            Form_Debug.Focus()
        ElseIf Form_Debug.Visible Then
            Form_Debug.Focus()
        Else
            RTB.Focus()
        End If
    End Sub
    Private Sub tkbar_Speed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Speed.ValueChanged
        If Not EventsAreEnabled Then Return
        ApplyEditorProps()
        ShowExecutionDelayText(tkbar_Speed.Value)
        tkbar_Speed.Refresh()
    End Sub
    Private Sub tkbar_Zoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Zoom.ValueChanged
        If Not EventsAreEnabled Then Return
        ApplyEditorProps()
        tkbar_Zoom.Refresh()
    End Sub

    Friend Sub ApplyEditorProps(Optional ByVal ForceNewZoom As Boolean = False)
        ' --------------------------------------------
        Dim z As Int32 = tkbar_Zoom.Value + 3
        Dim NewRtbZoom As Single = z / 11.0F
        If NewRtbZoom <> RTB.ZoomFactor Then
            ' -------------------------------------------- save scroll data
            Dim sd As SyntaxRichTextBox.ScrollData
            RTB.SaveSelectionAndScroll(sd)
            Dim OldPaintEvent As Boolean = RTB.PaintEventEnabled
            RTB.PaintEventEnabled = False
            ' ----- NO ENABLE = FALSE !!! --- (TO NOT FLASH SCROLLBARS)
            'Dim oldEnabled As Boolean = RTB.Enabled
            'RTB.Enabled = False
            ' ---------------------------------------- set zoom
            If ForceNewZoom Then
                RTB.ZoomFactor = 0.1
                PrintTextBox.ZoomFactor = 0.1
            End If
            RTB.ZoomFactor = NewRtbZoom
            PrintTextBox.ZoomFactor = NewRtbZoom * 0.8F
            RTB.Refresh()
            PrintTextBox.Refresh()
            ' -------------------------------------------- restore scroll data
            RTB.RestoreSelectionAndScroll(sd)
            RTB.PaintEventEnabled = OldPaintEvent
            'RTB.Enabled = oldEnabled
        End If
        MenuStrip_Edit.Font = New Font("Tahoma", 8 + CInt(z * 0.6))
        MenuStrip_Exit.Font = New Font("Tahoma", 8 + CInt(z * 0.6))
        Form_Debug.ListView1.Font = New Font("Microsoft Sans Serif", 6 + CInt(z * 0.5))
        SetExecutionDelayParams(tkbar_Speed.Value)
    End Sub

    Private Sub tkbar_Transparency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Transparency.ValueChanged
        If Not EventsAreEnabled Then Return
        SetFormOpacity()
        tkbar_Transparency.Refresh()
    End Sub

    Private Sub SetFormOpacity()
        Me.Opacity = 1 - tkbar_Transparency.Value / 20.0F
    End Sub

    Private Sub chk_ScrollEnabled_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ScrollEnabled.CheckedChanged
        If Not EventsAreEnabled Then Return
        UpdateScrollButton()
        RTB.Focus()
    End Sub

    Private Sub UpdateScrollButton()
        If chk_ScrollEnabled.Checked Then
            chk_ScrollEnabled.Text = "Scroll enabled"
            chk_ScrollEnabled.FlatAppearance.MouseOverBackColor = ModifiedColor(chk_ScrollEnabled.FlatAppearance.CheckedBackColor, 40)
        Else
            chk_ScrollEnabled.Text = "Scroll disabled"
            chk_ScrollEnabled.FlatAppearance.MouseOverBackColor = ModifiedColor(chk_ScrollEnabled.BackColor, 20)
        End If
    End Sub

    ' =============================================================================================
    '  PROGRAMMABLE BUTTONS
    ' =============================================================================================
    Friend Const NBUTTONS As Int32 = 128
    Private Const ButtonsWidth As Int32 = 160
    Private Const ButtonsHeight As Int32 = 46
    Private Const ButtonsLeft As Int32 = 9
    Private Const ButtonsTop As Int32 = 19

    Private Buttons(NBUTTONS - 1) As CheckBox
    Private ButtonEnabled(NBUTTONS - 1) As Boolean
    Private ButtonIdentifiers(NBUTTONS - 1) As String
    Private ButtonDeclarationLines(NBUTTONS - 1) As Int32
    Private ButtonSlots(NBUTTONS - 1) As Int32
    Private ButtonSlotsOldValues(NBUTTONS - 1) As Single
    Private ButtonFlashingFrequency(NBUTTONS - 1) As Single
    Private ButtonBackColor(NBUTTONS - 1) As Color
    Private ButtonForeColor(NBUTTONS - 1) As Color
    Private ButtonFlashingTimer(NBUTTONS - 1) As Single
    Private ButtonFlashingColor1(NBUTTONS - 1) As Color
    Private ButtonFlashingColor2(NBUTTONS - 1) As Color

    Private Sub Buttons_Create()
        For i As Int32 = 0 To NBUTTONS - 1
            Buttons(i) = New CheckBox
            With Buttons(i)
                .Appearance = Appearance.Button
                .FlatStyle = FlatStyle.Flat
                .FlatAppearance.BorderColor = Color.DarkGray
                .FlatAppearance.BorderSize = 2
                .FlatAppearance.CheckedBackColor = Color.OldLace
                .Font = New Font("Tahoma", 8.25)
                .Size = New Size(ButtonsWidth, ButtonsHeight)
                .Name = "Button_" + (i + 1).ToString
                .TextAlign = ContentAlignment.MiddleCenter
                .UseVisualStyleBackColor = False
                .Visible = False
            End With
            AddHandler Buttons(i).Click, AddressOf Buttons_Click
            GBox_Controls.Controls.AddRange(Buttons)
        Next
    End Sub

    Friend Sub SetInitialButtonNamesColorsAndPositions()
        ' ------------------------------------------------------------------------ set name and colors
        For i As Int32 = 0 To NBUTTONS - 1
            With Buttons(i)
                .Text = ""
                .BackColor = Color.OldLace
                .ForeColor = Color.Black
                ButtonBackColor(i) = .BackColor
                ButtonForeColor(i) = .ForeColor
                EnableButton(i)
                ButtonFlashingFrequency(i) = 0
                .FlatAppearance.BorderSize = 1
                .FlatAppearance.BorderColor = Color.Gray
            End With
        Next
        ' ------------------------------------------------------------------------ set positions
        SetButtonsPositions()
        SetVisibleButtons()
    End Sub

    Friend Sub SetButtonsPositions()
        Dim x As Int32 = CInt(ButtonsLeft * myResizer.GetRatio().Width)
        Dim y As Int32 = ButtonsTop
        Dim dw As Int32 = CInt((ButtonsWidth + 5) * myResizer.GetRatio().Width)
        Dim dh As Int32 = CInt((ButtonsHeight + 2) * myResizer.GetRatio().Height)
        Dim row As Int32
        Dim col As Int32
        For i As Int32 = 0 To NBUTTONS - 1
            With Buttons(i)
                row = i Mod 16
                col = i \ 16
                .Left = x + dw * col
                .Top = y + dh * row
            End With
        Next
    End Sub

    Private Sub Buttons_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        ExecButton(CType(sender, CheckBox))
    End Sub

    Private ButtonColumns As Int32
    Private OldButtonColumns As Int32

    Private Sub SetVisibleButtons()
        If Not EventsAreEnabled Then Return
        ' ---------------------------------------------------------------
        Dim b As CheckBox
        Dim ypos As Int32
        Dim column As Int32
        If Running Then
            ypos = chk_ControlsRun.Top - 2
        Else
            ypos = chk_ControlsGoToDeclaration.Top - 2
        End If
        ButtonColumns = 0
        For i As Int32 = 0 To NBUTTONS - 1
            b = Buttons(i)
            If b.Text <> Nothing Then
                If i > 15 Then
                    b.Visible = b.Bottom < GBox_Controls.ClientSize.Height - 4
                Else
                    b.Visible = b.Bottom < ypos
                End If
                SetButtonFontSize(b)

                column = i \ 16
                If column > ButtonColumns Then
                    ButtonColumns = column
                End If
            Else
                b.Visible = False
            End If
        Next
        If ButtonColumns <> OldButtonColumns Then
            OldButtonColumns = ButtonColumns
            ' ---------------------------------------------------------------
            ResizeControlAndProgramPanels()
            ' ---------------------------------------------------------------
            Me.MinimumSize = New Size(GBox_Program.Left + 16, Buttons(0).Height * 7)
            ' ---------------------------------------------------------------
            ShowHideTextAndTools()
        End If
    End Sub

    Private Sub ResizeControlAndProgramPanels()
        GBox_Controls.Width = Buttons(ButtonColumns * 16).Right + Buttons(0).Left
        GBox_Program.Left = GBox_Controls.Right + 6
        GBox_Program.Width = Me.ClientSize.Width - GBox_Program.Left - 6
        ' 
        Me.MinimumSize = New Size(GBox_Controls.Right + 24, GBox_Controls.Height - chk_ControlsBack.Top + StatusStrip1.Height + 64)
    End Sub

    Private Function GetButtonIndex(ByVal button As CheckBox) As Int32
        For i As Int32 = 0 To NBUTTONS - 1
            If button Is Buttons(i) Then
                Return i + 1
            End If
        Next
    End Function

    Private Function GetButtonByIdentifier(ByVal IdString As String) As Int32
        IdString = IdString.ToLower
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i).ToLower = IdString Then
                Return i + 1
            End If
        Next
        Return 0
    End Function

    Private Function GetButtonByIdentifierOrName(ByVal IdString As String) As Int32
        If IdString = "" Then Return 0
        IdString = IdString.ToLower
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i).ToLower = IdString OrElse Buttons(i).Text.ToLower = IdString Then
                Return i + 1
            End If
        Next
        Return 0
    End Function

    Private Sub ResetButtonIdentifiersAndSlots()
        For i As Int32 = 0 To NBUTTONS - 1
            ButtonSlots(i) = -1
            ButtonIdentifiers(i) = ""
        Next
    End Sub

    Private Sub EnableAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            EnableButton(i)
        Next
    End Sub
    Private Sub DisableAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            DisableButton(i)
        Next
    End Sub
    Private Sub EnableButton(ByVal n As Int32)
        ButtonEnabled(n) = True
        With Buttons(n)
            .ForeColor = ButtonForeColor(n)
            .BackColor = ButtonBackColor(n)
            .FlatAppearance.MouseOverBackColor = ModifiedColor(.BackColor, 90)
        End With
    End Sub
    Private Sub DisableButton(ByVal n As Int32)
        ButtonEnabled(n) = False
        With Buttons(n)
            .ForeColor = Color.FromArgb(80, 80, 80)
            .BackColor = Color.FromArgb(210, 210, 210)
            .FlatAppearance.MouseOverBackColor = Color.FromArgb(200, 200, 200)
        End With
    End Sub

    Private Sub UncheckAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            Buttons(i).Checked = False
        Next
    End Sub

    Private Sub ExecButtonsFromSlots()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonSlots(i) >= 0 Then
                Dim NewValue As Single = Slots.ReadSlot_NoNan(ButtonSlots(i))
                If NewValue > 500 And ButtonSlotsOldValues(i) <= 500 Then
                    Dim button As CheckBox
                    button = Buttons(i)
                    If ButtonEnabled(i) Then
                        button.Checked = True
                        ExecButton(button)
                    End If
                End If
                ButtonSlotsOldValues(i) = NewValue
            End If
        Next
    End Sub

    Private Sub ExecButton(ByVal button As CheckBox)
        If RTB_Lines Is Nothing Then Return
        Dim i As Int32 = GetButtonIndex(button)
        '
        Dim line As Int32 = RTB.FindLabel(RTB_Lines, ButtonIdentifiers(i - 1), True)
        If line >= 0 Then
            ' ------------------------------ execute button if running and not CTRL KEY pressed
            If Running And Not My.Computer.Keyboard.CtrlKeyDown Then
                If ButtonEnabled(i - 1) Then
                    ExecutionThread_Stop()
                    If ExistsReturn(line) Then
                        ReturnStack.Push(LineInExecution)
                    End If
                    GotoLine = line
                    ExecutionThread_Start()
                End If
            End If
        End If
        ' --------------------------------- change line to button declaration line (if no label or CTRL pressed)
        If line < 0 Or (Not Running And My.Computer.Keyboard.CtrlKeyDown) Then
            line = ButtonDeclarationLines(GetButtonIndex(button) - 1)
        End If
        ' --------------------------------- goto button execution Label or button declaration
        If Not Running Or My.Computer.Keyboard.CtrlKeyDown Then
            RTB.ScrollToCenterLine(line)
            RTB.Select(RTB.GetFirstCharIndexFromLine(line), 0)
            RTB.Hilighter_AddExecutedLine(line)
        End If
        ' ---------------------------------- a little delay so Wait-Button can see the button checked 
        Threading.Thread.Sleep(20)
        button.Checked = False
    End Sub

    ' ---------------------------------------------------------------------------------------------
    ' This function is used by ExecButton and PollKeys
    '  The test is made on the indented text and excludes indented keywords
    '  so "return", "goto", "stop" and "label" are considered only if at the beginning of the line
    ' ---------------------------------------------------------------------------------------------
    Private Function ExistsReturn(ByVal FromLine As Int32) As Boolean
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = FromLine + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).ToLower
            If line.StartsWith("return") Then
                If counter = 0 Then
                    Return True
                End If
                counter -= 1
            ElseIf line.StartsWith("goto") Then
                counter -= 1
            ElseIf line.StartsWith("stop") Then
                counter -= 1
            ElseIf line.StartsWith("label") Then
                counter += 1
            End If
            If counter < 0 Then
                Return False
            End If
        Next
        Return False
    End Function

    ' ---------------------------------------------------------------------------------------------
    ' This function is used only by TestSlot_ExternalCommands
    ' Maybe could be used also by the functions ExecButton and PollKeys
    ' ---------------------------------------------------------------------------------------------
    '  The test is made on the indented text and excludes indented keywords
    '  so "return", "goto", "stop" and "label" are considered only if at the beginning of the line
    ' ---------------------------------------------------------------------------------------------
    Friend Function GetReturnLineNumber(ByVal FromLine As Int32) As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = FromLine + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).ToLower
            If line.StartsWith("return") Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("goto") Then
                counter -= 1
            ElseIf line.StartsWith("stop") Then
                counter -= 1
            ElseIf line.StartsWith("label") Then
                counter += 1
            End If
            If counter < 0 Then
                Return -1
            End If
        Next
        Return -1
    End Function

    Private Sub ExecFlashingButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonFlashingFrequency(i) > 0 Then
                ButtonFlashingTimer(i) -= Timer50ms.Interval
                If ButtonFlashingTimer(i) <= 0 Then
                    ButtonFlashingTimer(i) = 1000 / ButtonFlashingFrequency(i)
                    Dim b As CheckBox = Buttons(i)
                    If b.BackColor = ButtonFlashingColor1(i) Then
                        b.BackColor = ButtonFlashingColor2(i)
                    Else
                        b.BackColor = ButtonFlashingColor1(i)
                    End If
                    CorrectButtonForeColor(b, i + 1)
                End If
            End If
        Next
    End Sub

    Private Sub AllFlashingButtonsToFirstColor()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonFlashingFrequency(i) > 0 Then
                Dim b As CheckBox = Buttons(i)
                b.BackColor = ButtonFlashingColor1(i)
                ButtonBackColor(i) = b.BackColor
                CorrectButtonForeColor(b, i + 1)
            End If
        Next
    End Sub

    Private Sub CorrectButtonForeColor(ByVal b As CheckBox, ByVal buttonIndexBase1 As Int32)
        If GrayScaleLuminance(b.BackColor) < 145 Then
            b.ForeColor = Color.White
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, 90)
        Else
            b.ForeColor = Color.Black
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, -30)
        End If
        ButtonForeColor(buttonIndexBase1 - 1) = b.ForeColor
    End Sub

    Private Sub SetButtonFontSize(ByVal b As CheckBox)
        '
        Dim fontsize As Single = b.Height / 5.0F
        ' --------------------------------------------------------- avoid errors if the form is zero size
        If fontsize = 0 Then fontsize = 9.2
        ' ---------------------------------------------------------
        b.Font = New Font("Tahoma", fontsize * 1.6F)
        Dim pixels As Size = TextRenderer.MeasureText(b.Text, b.Font)
        If b.Text.Contains(vbCrLf) Then
            ' ----------------------------------------------------- font for two lines
            b.Font = New Font("Tahoma", fontsize * 1.1F)
            ' ----------------------------------------------------- try to correct for long names also if containing spaces
            Dim sa() As String = Strings.Split(b.Text, vbCrLf)
            Dim MaxWidth As Int32 = -1
            For i As Int32 = 0 To sa.Length - 1
                pixels = TextRenderer.MeasureText(sa(i), b.Font)
                If pixels.Width > MaxWidth Then
                    MaxWidth = pixels.Width
                End If
            Next
            If MaxWidth >= b.Width - 10 Then
                b.Font = New Font("Tahoma", CSng(fontsize * 1.1F * (b.Width - 10) / MaxWidth))
            End If
        ElseIf pixels.Width >= b.Width - 10 Then
            b.Font = New Font("Tahoma", CSng(fontsize * 1.5F * (b.Width - 10) / pixels.Width))
        End If
    End Sub


    ' =============================================================================================
    '   EXECUTION HELPING FUNCTIONS - WITH Invoke from Worker-Thread to UserInterface-Thread
    ' =============================================================================================
    Private Delegate Sub SetButton_Delegate(ByVal BtnID As String, ByVal text As String, ByVal line As Int32)
    Private Sub SetButton_ThreadSafe(ByVal BtnID As String, ByVal text As String, ByVal line As Int32)
        If InvokeRequired Then
            Invoke(New SetButton_Delegate(AddressOf SetButton_ThreadSafe), BtnID, text, line)
        Else
            ' ------------------------------------------------- test if the ID is number or identifier
            Dim IdentifiedByNumber As Boolean = True
            Dim nbutton As Int32 = CInt(EvalDouble(BtnID))
            If nbutton = 0 Then
                nbutton = GetButtonByIdentifier(BtnID)
                IdentifiedByNumber = False
            End If
            If nbutton < 1 Or nbutton > NBUTTONS Then Return
            ' -------------------------------------------------
            Dim b As CheckBox
            b = Buttons(nbutton - 1)
            If b Is Nothing Then Return
            If text = Nothing Then
                b.Text = Nothing
                ButtonIdentifiers(nbutton - 1) = ""
                SetVisibleButtons()
                Return
            End If
            Select Case text.ToLower
                Case "enabled"
                    EnableButton(nbutton - 1)
                    SetVisibleButtons()
                Case "disabled"
                    DisableButton(nbutton - 1)
                    SetVisibleButtons()
                Case Else
                    text = text.Replace("""", "")
                    If text <> b.Text Then
                        b.Text = text
                        If IdentifiedByNumber Then
                            ButtonDeclarationLines(nbutton - 1) = line
                            ButtonIdentifiers(nbutton - 1) = text
                            SetVisibleButtons()
                        End If
                        SetButtonFontSize(b)
                        b.Refresh()
                    End If
            End Select
        End If
    End Sub

    Private Delegate Sub SetButtonSlot_Delegate(ByVal nbutton As Int32, ByVal slot As Int32)
    Private Sub SetButtonSlot_ThreadSafe(ByVal nbutton As Int32, ByVal slot As Int32)
        If InvokeRequired Then
            Invoke(New SetButtonSlot_Delegate(AddressOf SetButtonSlot_ThreadSafe), nbutton, slot)
        Else
            If nbutton < 1 Or nbutton > ButtonSlots.Length Then Return
            ButtonSlots(nbutton - 1) = slot
        End If
    End Sub

    Private Delegate Sub UncheckAllButtons_Delegate()
    Private Sub UncheckAllButtons_ThreadSafe()
        If InvokeRequired Then
            Invoke(New UncheckAllButtons_Delegate(AddressOf UncheckAllButtons_ThreadSafe))
        Else
            UncheckAllButtons()
        End If
    End Sub

    Private Delegate Sub CloseApplication_Delegate()
    Private Sub CloseApplication_ThreadSafe()
        If InvokeRequired Then
            Invoke(New CloseApplication_Delegate(AddressOf CloseApplication_ThreadSafe))
        Else
            Me.Close()
        End If
    End Sub

    Private TextBoxMaxChars As Int32 = 32000
    Private Delegate Sub Print_Message_Delegate(ByVal message As String, ByVal TestPrintTextBox As Boolean)
    Private Sub Print_Message_ThreadSafe(ByVal message As String, ByVal TestPrintTextBox As Boolean)
        If InvokeRequired Then
            ' ------------------------------------ wait the command execution with "Invoke" (not "Begin Invoke")
            Invoke(New Print_Message_Delegate(AddressOf Print_Message_ThreadSafe), message, TestPrintTextBox)
        Else
            If TestPrintTextBox AndAlso PrintTextBox.Visible Then
                Dim oldPaintEvent As Boolean = PrintTextBox.PaintEventEnabled
                Dim oldEnabled As Boolean = PrintTextBox.Enabled
                PrintTextBox.PaintEventEnabled = False
                PrintTextBox.Enabled = False
                If message.StartsWith(Chr(12)) Then
                    message = message.Substring(1)
                    PrintTextBox.Clear()
                End If
                ' ----------------------------------------------------------------------------- PrintTextBox length limited to 32000 chars
                If PrintTextBox.Text.Length < TextBoxMaxChars Then
                    PrintTextBox.AppendText(message)
                Else
                    PrintTextBox.Text = "--- Reached the max capacity of " + _
                                        TextBoxMaxChars.ToString + " chars ---" + vbCrLf + _
                                        Strings.Right(PrintTextBox.Text, TextBoxMaxChars) + message
                End If
                ' ----------------------------------------------------------------------------- 
                PrintTextBox.SelectionStart = PrintTextBox.Text.Length + 1
                PrintTextBox.ScrollToCaret()
                PrintTextBox.Enabled = oldEnabled
                PrintTextBox.PaintEventEnabled = oldPaintEvent

                ' Removed 17 02 2020 
                ' Otherwise the STOP button not works with program "Test COM - SEND RND.txt"
                'PrintTextBox.Focus()
            Else
                SetStatusLabelFontFixed()
                If message.Trim.ToLower.StartsWith("error") Then
                    StatusLabel1.BackColor = Color.FromArgb(255, 160, 150)
                ElseIf message.Trim.ToLower.StartsWith("warning") Then
                    StatusLabel1.BackColor = RTB.Color_WarningBack
                    ' ---------------------------------------------------------- if paused then color the borders
                    If message.Trim.ToLower.StartsWith("warning : pause") Then
                        Me.BackColor = Color.Orange
                        GBox_Controls.BackColor = Color.Orange
                    End If
                Else
                    If Me.BackColor = Color.Orange Then
                        Me.BackColor = Color.AliceBlue
                        GBox_Controls.BackColor = Color.Cornsilk
                    End If
                    StatusLabel1.BackColor = Color.FromArgb(220, 255, 200)
                End If
                ' limit length for speed and because strings more than 40000 are not visualized
                Static trimChars() As Char = New Char() {Chr(10), Chr(13)}
                message = message.TrimEnd(trimChars)
                StatusLabel1.Text = Strings.Left(message, 999)
                StatusLabel1.Invalidate()
            End If
        End If
    End Sub

    Private Delegate Sub SetNewSpeed_Delegate(ByVal speed As Double)
    Private Sub SetNewSpeed_ThreadSafe(ByVal speed As Double)
        If InvokeRequired Then
            Invoke(New SetNewSpeed_Delegate(AddressOf SetNewSpeed_ThreadSafe), speed)
        Else
            Dim OldEventsAreEnabled As Boolean = EventsAreEnabled
            EventsAreEnabled = False
            tkbar_Speed.Value = CInt(speed)
            EventsAreEnabled = OldEventsAreEnabled
            SetExecutionDelayParams(CInt(speed))
        End If
    End Sub

    Private Delegate Sub SetNewTransparency_Delegate(ByVal transparency As Double)
    Private Sub SetNewTransparency_ThreadSafe(ByVal transparency As Double)
        If InvokeRequired Then
            Invoke(New SetNewTransparency_Delegate(AddressOf SetNewTransparency_ThreadSafe), transparency)
        Else
            tkbar_Transparency.Value = CInt(transparency)
        End If
    End Sub

    Private Delegate Sub StopRunning_Delegate()
    Private Sub StopRunning_ThreadSafe()
        Running = False
        If InvokeRequired Then
            Invoke(New StopRunning_Delegate(AddressOf StopRunning_ThreadSafe))
        Else
            StopRunning()
        End If
    End Sub

    Private Delegate Sub StopRunning_DontCallLabel_Delegate()
    Private Sub StopRunning_DontCallLabel_ThreadSafe()
        Running = False
        If InvokeRequired Then
            Invoke(New StopRunning_DontCallLabel_Delegate(AddressOf StopRunning_DontCallLabel_ThreadSafe))
        Else
            StopRunning(True, False)
        End If
    End Sub

    Private Delegate Sub StopRunning_DontRestoreScrollAndDontCallLabel_Delegate()
    Private Sub StopRunning_DontRestoreScrollAndDontCallLabel_ThreadSafe()
        Running = False
        If InvokeRequired Then
            Invoke(New StopRunning_DontCallLabel_Delegate(AddressOf StopRunning_DontRestoreScrollAndDontCallLabel_ThreadSafe))
        Else
            StopRunning(False, False)
        End If
    End Sub

    Private Delegate Sub InputDialog_Delegate(ByVal varname As String, ByVal prompt As String, ByVal type As String)
    Private Sub InputDialog_ThreadSafe(ByVal varname As String, ByVal prompt As String, ByVal type As String)
        If InvokeRequired Then
            Invoke(New InputDialog_Delegate(AddressOf InputDialog_ThreadSafe), varname, prompt, type)
        Else
            '
            DisableKeys = True ' kets are disabled while box are open
            '
            If type = "input" Then
                Form_Input.Text = "Input from Automation"
                Form_Input.txt_Input.Text = ""
                Form_Input.txt_Input.Visible = True
                Form_Input.chk_Cancel.Text = "CANCEL"
                Form_Input.chk_Ok.Text = "OK"
                Form_Input.Prompt = prompt
                Form_Input.ShowDialog(Me)
                If Form_Input.ValidInput Then
                    SetVariable(varname, Form_Input.txt_Input.Text)
                End If
            Else
                Form_Input.Text = "Message from Automation"
                Form_Input.txt_Input.Text = ""
                Form_Input.txt_Input.Visible = False
                Form_Input.chk_Cancel.Text = "NO"
                Form_Input.chk_Ok.Text = "YES"
                Form_Input.Prompt = prompt
                Form_Input.ShowDialog(Me)
                If IsStringVariable(varname) Then
                    SetVariable(varname, If(Form_Input.ValidInput, "YES", "NO"))
                Else
                    SetVariable(varname, If(Form_Input.ValidInput, "1", "0"))
                End If
            End If
            '
            DisableKeys = False
        End If
    End Sub

    ' =============================================================================================
    '   LOAD MEDIA
    ' =============================================================================================
    Private Delegate Sub Load_Media_Delegate(ByVal filename As String)
    Private Sub Load_Media_ThreadSafe(ByVal filename As String)
        If InvokeRequired Then
            ' ------------------------------------ wait the command execution with "Invoke" (not "BeginInvoke")
            Invoke(New Load_Media_Delegate(AddressOf Load_Media_ThreadSafe), filename)
        Else
            If filename Is Nothing Then filename = "stop"
            '
            ' ---------------------------------------------------- VIDEO and AUDIO POSITION
            If filename.ToLower.Trim.StartsWith("position") Then
                Dim sa() As String = filename.Split(" "c)
                If sa.Length = 2 Then
                    WMP.Ctlcontrols.currentPosition = EvalDouble(sa(1))
                    filename = ""
                End If
            End If
            '
            ' ---------------------------------------------------- PAUSE PLAY STOP HIDE and LOAD-FILE
            Select Case filename.ToLower
                Case "pause" : WMP.Ctlcontrols.pause()
                Case "play" : WMP.Ctlcontrols.play()
                Case "stop" : WMP.URL = "" : WebBrowserStop()
                Case "hide" : PreparePanelsForProgram()
                Case Else
                    Try
                        LoadMediaFile(filename)
                    Catch
                    End Try
            End Select
            Refresh()
            ' ------------------------------------- set buttons parent depending on ViewMode and PanelMode
            SetButtonsParent()
        End If
    End Sub

    Private Sub LoadMediaFile(ByVal filename As String)
        Dim fullPath As String
        ' -------------------------------------------------------------------- ensure the Application.Path as current directory
        SetAppPathAsDefaultCurrentDir()
        ' -------------------------------------------------------------------- replace var-names with var-strings
        Dim f As String = ReplaceVarNamesWithVarStrings(filename)
        If f <> "" Then filename = f
        ' -------------------------------------------------------------------- load txt to variable
        If Not filename.Contains("+") Then
            Dim sa() As String = filename.Split(" "c)
            If sa.Length > 1 AndAlso IsStringVariable(sa(0)) Then
                sa(1) = sa(sa.Length - 1)
                sa(1) = sa(1).Replace("""", "")
                If IsStringVariable(sa(1)) Then
                    sa(1) = GetStringVariable(sa(1))
                End If
                ' -------------------------------------------------------- try near to program file
                fullPath = IO.Path.GetDirectoryName(ProgramFile_PathAndName) + "\" + sa(1)
                ' -------------------------------------------------------- else try the "Files" folder
                If Not My.Computer.FileSystem.FileExists(fullPath) Then
                    fullPath = PlatformAdjustedFileName(Application.StartupPath + "\Files\" + sa(1))
                End If
                ' -------------------------------------------------------- else try the path itself
                If Not My.Computer.FileSystem.FileExists(fullPath) Then
                    fullPath = sa(1)
                End If
                ' -------------------------------------------------------- load
                If My.Computer.FileSystem.FileExists(fullPath) Then
                    SetVariable(sa(0), IO.File.ReadAllText(fullPath))
                Else
                    SetVariable(sa(0), "")
                End If
                Return
            End If
        End If
        ' ------------------------------------------------------------------ normal media load
        If filename.StartsWith("http", StringComparison.InvariantCultureIgnoreCase) Then
            WebBrowserStart(filename)
            ' -------------------------------------------------------------- FILES WITH CMD LINE
        ElseIf FileExists_RemovingCmdLine(filename) AndAlso filename.Split(" "c).Length > 1 Then
            OpenFileWithProcessStart(filename)
        Else
            ' -------------------------------------------------------------- LOAD FILE
            filename = filename.Replace("""", "")
            Select Case IO.Path.GetExtension(filename.ToLower)
                Case ".txt"
                    fullPath = Application.StartupPath + "\" + filename
                    If My.Computer.FileSystem.FileExists(fullPath) And filename.ToLower.StartsWith("programs") Then
                        ' -------------------------------------------------- if the TXT file is inside the "Programs" folder load it as a program
                        ExecutionThread_Stop()
                        Load_Program(fullPath)
                        RTB_Lines = RTB.Lines
                        GotoLine = 0
                        ExecutionThread_Start()
                    Else
                        OpenFileWithProcessStart(filename)
                    End If
                Case ".jpg", ".jpeg", ".bmp", ".png", ".exif", ".tiff", ".svg"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & RemoveMediaPrefix(filename))
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        GBox_Program.Text = filename
                        PictureBox1.Image = Image.FromFile(fullPath)
                        PreparePanelsForImages()
                        GBox_Program.Text = filename
                    End If
                Case ".avi", ".wmv", ".mpg", ".mpeg", ".m2ts", ".m3u", ".mp4", ".m4v", ".mp4v", ".3g2", ".3gp2", ".3gp", ".3gpp", ".mov", ".gif"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & RemoveMediaPrefix(filename))
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        GBox_Program.Text = "Loading """ + filename + """   >>> PLEASE WAIT SOME SECONDS <<<"
                        SetWmpVolumeAndBalance()
                        WMP.URL = fullPath
                        WMP_WaitReady()
                        PreparePanelsForVideo()
                        GBox_Program.Text = filename
                    End If
                Case ".mp3", ".wav", ".m4a", ".aif", ".aifc", ".aiff", ".au", ".snd", ".aac", ".adt", ".adts", ".flac", ".mid", ".midi", ".rmi"
                    fullPath = PlatformAdjustedFileName(Application.StartupPath & "\Media\" & RemoveMediaPrefix(filename))
                    If My.Computer.FileSystem.FileExists(fullPath) Then
                        'GBox_Program.Text = filename ' not showing name because not visible
                        WMP.Hide()
                        SetWmpVolumeAndBalance()
                        WMP.URL = fullPath
                        WMP_WaitReady()
                        'GBox_Program.Text = filename ' not showing name because not visible
                    Else
                        ' if not existing then play a default sound
                        My.Computer.Audio.Play(My.Resources.beep2, AudioPlayMode.WaitToComplete)
                    End If
                Case ".exe"
                    ' -------------------------------------------------------------- FIND FILE IF NOT EXISTS
                    If Not IO.File.Exists(filename) Then
                        If Not FileExists_RemovingCmdLine(filename) Then
                            filename = FindFilePathByName(filename, Application.StartupPath + "\Apps\")
                        End If
                    End If
                    StartProcess_IfNotRunning_AndWait(filename, False)
                    Me.Activate()
                Case Else
                    ' -------------------------------------------------------------- FIND FILE IF NOT EXISTS
                    If Not FileExists_RemovingCmdLine(filename) Then
                        filename = FindFilePathByName(filename, Application.StartupPath + "\Apps\")
                    End If
                    OpenFileWithProcessStart(filename)
            End Select
        End If
        ExecutionDelay_Variable()
    End Sub

    ' ------------------------------------------ WMP SETTINGS - VOLUME and BALANCE - UNUSED
    Friend WmpVolume As Int32 = 100
    Friend WmpBalance As Int32 = 0
    Friend Sub SetWmpVolumeAndBalance()
        ' -------------------------------------- volume = 0 to +100
        WMP.settings.volume = WmpVolume
        ' -------------------------------------- balance = -100 to +100
        WMP.settings.balance = WmpBalance
    End Sub


    Private Function FileExists_RemovingCmdLine(ByVal FilePathAndCmdLine As String) As Boolean
        Dim sa() As String = FilePathAndCmdLine.Split(" "c)
        sa(0) = sa(0).Replace("""", "")
        ' -------------------------------------------------------------- Get full path
        FilePathAndCmdLine = IO.Path.GetFullPath(sa(0))
        ' -------------------------------------------------------------- Test if the path is an existent directory
        If IO.Directory.Exists(sa(0)) Then Return True
        ' -------------------------------------------------------------- Test if the path is an existent file
        If IO.File.Exists(sa(0)) Then Return True
        ' -------------------------------------------------------------- remove the ".exe" and test if the file exists
        Dim i As Int32 = FilePathAndCmdLine.IndexOf(".exe")
        If i > 0 Then
            sa(0) = Strings.Left(sa(0), i + 4)
        End If
        Return My.Computer.FileSystem.FileExists(sa(0))
    End Function

    Private Function ReplaceVarNamesWithVarStrings(ByVal f As String) As String
        Dim sa() As String = f.Split(" "c)
        f = ""
        For i As Int32 = 0 To sa.Length - 1
            Dim s As String = EvalString_AutoQuoting(sa(i))
            If s <> "" Then sa(i) = s
            f += sa(i) + " "
        Next
        Return f.Trim
    End Function

    Private Sub OpenFileWithProcessStart(ByVal filename As String)
        Dim f As String = filename
        If f = "" Then Return
        ' ------------------------------------------------------- try to open an app with CommandLine Parameters
        Dim sa() As String = f.Split(" "c)
        If sa.Length >= 2 Then
            ' --------------------------------------------------- open also file names with spaces
            Dim s As String = ""
            For i As Int32 = 1 To sa.Length - 1
                s += sa(i) + " "
            Next
            ReDim Preserve sa(1)
            sa(1) = s.Trim
            ' --------------------------------------------------- if the command line is a path then get the full path 
            s = IO.Path.GetFullPath(s)
            ' --------------------------------------------------- if the file not exists then use the command line as it is
            If Not IO.File.Exists(s) Then
                s = sa(1)
            End If
            ' --------------------------------------------------- get the full path 
            sa(0) = IO.Path.GetFullPath(sa(0))
            ' --------------------------------------------------- add quotes to acceps also command lines containing spaces 
            ' --------------------------------------------------- Removed because some applications do not accept the """ """
            'sa(1) = """" + s + """"
            ' --------------------------------------------------- start the process with the command line
            Process.Start(sa(0), sa(1))
            AddProcessToOpenedProcessesList(sa(0))
        End If
        ' ------------------------------------------------------- test also if it is a folder
        If My.Computer.FileSystem.DirectoryExists(f) Then
            Process.Start(f)
            Return
        End If
        f = Application.StartupPath + "\" + filename.Replace("""", "") '+ "\"
        If My.Computer.FileSystem.DirectoryExists(f) Then
            Process.Start(f)
            Return
        End If
        ' ------------------------------------------------------- otherwise open it with the default Windows editor (maybe NotePad)
        If Not My.Computer.FileSystem.FileExists(f) Then
            f = PlatformAdjustedFileName(Application.StartupPath + "\Files\" + RemoveFilesPrefix(filename))
        End If
        If Not My.Computer.FileSystem.FileExists(f) Then
            f = IO.Path.GetDirectoryName(ProgramFile_PathAndName) + "\" + filename
        End If
        If My.Computer.FileSystem.FileExists(f) Then
            Process.Start(f)
            Return
        End If
        ' ------------------------------------------------------- test also if it is a folder
        f = Application.StartupPath + "\" + filename.Replace("""", "") '+ "\"
        If My.Computer.FileSystem.DirectoryExists(f) Then
            Process.Start(f)
        End If
    End Sub

    Private Function RemoveProgramsPrefix(ByRef str As String) As String
        str.Replace("/", "\")
        If str.ToLower.StartsWith("programs\") Then
            str = Strings.Replace(str, "programs\", "", , , CompareMethod.Text)
        End If
        Return str
    End Function

    Private Function RemoveFilesPrefix(ByRef str As String) As String
        str.Replace("/", "\")
        If str.ToLower.StartsWith("files\") Then
            str = Strings.Replace(str, "files\", "", , , CompareMethod.Text)
        End If
        Return str
    End Function

    Private Function RemoveMediaPrefix(ByRef str As String) As String
        str.Replace("/", "\")
        If str.ToLower.StartsWith("media\") Then
            str = Strings.Replace(str, "media\", "", , , CompareMethod.Text)
        End If
        Return str
    End Function

    ' -----------------------------------------------------------
    '  WMP PLAY STATE CHANGE
    ' -----------------------------------------------------------
    ' 0 Undefined
    ' 1 Stopped
    ' 2 Paused
    ' 3 Playing
    ' 4 ScanForward
    ' 5 ScanReverse
    ' 6 Buffering
    ' 7 Waiting
    ' 8 MediaEnded
    ' 9 Transitioning
    ' 10 Ready
    ' 11 Reconnecting
    ' -----------------------------------------------------------
    Private Sub WMP_PlayStateChange(ByVal sender As Object, ByVal e As AxWMPLib._WMPOCXEvents_PlayStateChangeEvent) Handles WMP.PlayStateChange
        Select Case e.newState
            Case 3, 4, 5, 6, 7
                EvalFunctions.WmpIsPlaying = True
                EvalFunctions.WmpMediaLength = WMP.Ctlcontrols.currentItem.duration
            Case 8, 10
                EvalFunctions.WmpIsPlaying = False
        End Select
    End Sub



    ' =============================================================================================
    '   EXECUTION HELPING FUNCTIONS - Directly executed in the Worker-Thread
    ' =============================================================================================

    ' ----------------------------------------------------------------
    '  ExecutionDelayVariable_WaitSeconds
    ' ----------------------------------------------------------------
    Private EDV_WaitSecondsStopWatch As Stopwatch = New Stopwatch
    Private EDV_ResetStopWatchEnabled As Boolean = True
    Private Sub ExecutionDelayVariable_WaitSeconds(ByVal seconds As Double)
        If EDV_ResetStopWatchEnabled Then
            EDV_WaitSecondsStopWatch.Reset()
            EDV_WaitSecondsStopWatch.Start()
        End If
        EDV_ResetStopWatchEnabled = True
        Do
            If EventTimer_Exec() Then
                EDV_ResetStopWatchEnabled = False
                Exit Do
            End If
            Thread.Sleep(1)
        Loop Until EDV_WaitSecondsStopWatch.Elapsed.TotalSeconds >= seconds OrElse TerminateThread = True OrElse Running = False
    End Sub


    ' ----------------------------------------------------------------
    '  WaitSeconds
    ' ----------------------------------------------------------------
    Private WaitSecondsStopWatch As Stopwatch = New Stopwatch
    Private ResetStopWatchEnabled As Boolean = True
    Private Sub Wait_Seconds(ByVal seconds As Double)
        If ResetStopWatchEnabled Then
            WaitSecondsStopWatch.Reset()
            WaitSecondsStopWatch.Start()
        End If
        ResetStopWatchEnabled = True
        Do
            If EventTimer_Exec() Then
                ResetStopWatchEnabled = False
                Exit Do
            End If
            Thread.Sleep(1)
            TestPauseButton()
        Loop Until WaitSecondsStopWatch.Elapsed.TotalSeconds >= seconds OrElse TerminateThread = True OrElse Running = False
    End Sub

    ' ----------------------------------------------------------------
    '  Wait_Forever
    ' ----------------------------------------------------------------
    Sub Wait_Forever()
        Do
            If EventTimer_Exec() Then Exit Do
            Thread.Sleep(1)
            TestPauseButton()
        Loop Until TerminateThread = True OrElse Running = False
    End Sub

    ' ----------------------------------------------------------------
    '  Wait_Button
    ' ----------------------------------------------------------------
    Sub Wait_Button(ByVal ButtonID As String)
        Thread.Sleep(50)
        Dim button As CheckBox = Nothing
        ButtonID = ButtonID.ToLower
        ' --------------------------------------------------- test identifier
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i).ToLower = ButtonID Then
                button = Buttons(i)
                Exit For
            End If
        Next
        ' --------------------------------------------------- test first word of name
        If button Is Nothing Then
            ButtonID = RTB.ExtractFirstWord(ButtonID).ToLower
            For i As Int32 = 0 To NBUTTONS - 1
                If RTB.ExtractFirstWord(ButtonIdentifiers(i)).ToLower = ButtonID Then
                    button = Buttons(i)
                    Exit For
                End If
            Next
        End If
        ' --------------------------------------------------- wait the button checked (after release)
        If button IsNot Nothing Then
            Do
                If EventTimer_Exec() Then Exit Do
                Thread.Sleep(5)
                TestPauseButton()
            Loop Until button.Checked OrElse TerminateThread = True OrElse Running = False
            UncheckAllButtons_ThreadSafe()
        End If
    End Sub

    Sub Wait_Process(ByVal ProcessName As String)
        Do
            If EventTimer_Exec() Then Exit Do
            Thread.Sleep(5)
            TestPauseButton()
        Loop Until Not ProcessRunning(ProcessName) OrElse TerminateThread = True OrElse Running = False
    End Sub

    Friend Sub Beep_RepetitionLimited(ByVal ms As Int32)
        Static sw As Stopwatch
        If sw Is Nothing Then
            sw = New Stopwatch
        Else
            If sw.ElapsedMilliseconds < ms Then Return
        End If
        sw.Reset()
        sw.Start()
        Beep()
    End Sub

    Private Function FindElseOrEndif() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line.StartsWith("else") Then
                If counter = 0 Then  ' changed from "<=" to "=" since version 3.6
                    Return i
                End If
            ElseIf line.StartsWith("endif") Then
                If counter = 0 Then  ' changed from "<=" to "=" since version 3.6
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("if") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindEndif() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line.StartsWith("endif") Then
                If counter = 0 Then  ' changed from "<=" to "=" since version 3.6
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("if") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindNext(ByVal order As Int32) As Int32
        If order < 1 Then order = 1
        Dim counter As Int32 = order - 1
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line.StartsWith("next") Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("for") Then
                counter += 1
            End If
        Next
        Return -1
    End Function


    ' =============================================================================================
    '  FIND CASE - Numeric and String
    ' =============================================================================================
    Private Function FindCaseNumeric(ByVal d As Double) As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line.StartsWith("case") Then
                If counter = 0 Then
                    ' ----------------------------------------------------------- Tokenize to array of keywords
                    Dim l() As String = RTB.Tokenize(RTB_Lines(i).Trim)
                    If l.Length > 1 AndAlso d = EvalDouble(l(1)) Then
                        Return i
                    End If
                End If
            ElseIf line.StartsWith("endselect") Then
                counter -= 1
                If counter < 0 Then Return -1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindCaseString(ByVal s As String) As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line.StartsWith("case") Then
                If counter = 0 Then
                    ' ----------------------------------------------------------- Tokenize to array of keywords
                    Dim l() As String = RTB.Tokenize(RTB_Lines(i).Trim)
                    ' ----------------------------------------------------------- SELECT is case insensitive
                    If l.Length > 1 AndAlso s.ToLower = EvalString(l(1)).ToLower Then
                        Return i
                    End If
                End If
            ElseIf line.StartsWith("endselect") Then
                counter -= 1
                If counter < 0 Then Return -1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    ' =============================================================================================
    '  FIND CASE ELSE and END SELECT  - ORIGINAL 2020
    ' =============================================================================================
    Private Function FindCaseElse() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line = "caseelse" Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function

    Private Function FindEndselect() As Int32
        Dim counter As Int32 = 0
        Dim line As String
        For i As Int32 = LineInExecution + 1 To RTB_Lines.Length - 1
            line = RTB_Lines(i).Trim.ToLower
            If line.StartsWith("endselect") Then
                If counter = 0 Then
                    Return i
                End If
                counter -= 1
            ElseIf line.StartsWith("select") Then
                counter += 1
            End If
        Next
        Return -1
    End Function


    ' =============================================================================================
    '  Keyboard Keys Events
    ' =============================================================================================
    Private Structure KeyEvent
        Public KeyCode As Keys
        Public IsGosub As Boolean
        Public LabelText As String
    End Structure
    Private KeyEvents(-1) As KeyEvent
    Private Sub ClearKeyEvents()
        ReDim KeyEvents(-1)
        ClearKeyEventsStackIndex()
    End Sub

    Private Sub SetKeyEvent(ByVal s1 As String, ByVal s2 As String, ByVal s3 As String)
        Dim k As Keys = GetKeyCode(s1)
        Dim ix As Int32 = -1
        ' -------------------------------------------- test if KeyCode already exists
        For i As Int32 = 0 To KeyEvents.Length - 1
            If k = KeyEvents(i).KeyCode Then
                ix = i
            End If
        Next
        ' -------------------------------------------- if not exists create a new place
        If ix < 0 Then
            ix = KeyEvents.Length
            ReDim Preserve KeyEvents(ix)
        End If
        ' -------------------------------------------- add the new KeyEvent
        With KeyEvents(ix)
            .KeyCode = k
            .IsGosub = s2.ToLower = "gosub"
            .LabelText = s3.ToLower
        End With
    End Sub

    Private DisableKeys As Boolean = False
    Private PollKeysRepeatStatus As Int32 = 0
    Friend Sub PollKeys()
        ' ------------------------------------------------------ if WEB navigating then KEYS are disabled
        If PanelMode = PanelModes.Web Then Return
        ' ------------------------------------------------------ if InputBox or MessageBox are open then KEYS are disabled
        If DisableKeys Then Return
        ' ------------------------------------------------------ do not accumulate stacked keys
        If KeyEventsStackIndex < ReturnStack.Count Then Return
        KeyEventsStackIndex = ReturnStack.Count
        ' ------------------------------------------------------ exec the key
        For Each k As KeyEvent In KeyEvents
            If KeyPressedNow(k.KeyCode) Then
                Dim line As Int32 = RTB.FindLabel(RTB_Lines, k.LabelText)
                If line >= 0 Then
                    ' ------------------------------------------ autorepeat initial pause of 15 * 20 mS
                    PollKeysRepeatStatus += 1
                    If PollKeysRepeatStatus > 1 And PollKeysRepeatStatus < 15 Then
                        Return
                    End If
                    ' ------------------------------------------ 
                    ExecutionThread_Stop()
                    If k.IsGosub And ExistsReturn(line) Then
                        ReturnStack.Push(LineInExecution)
                        'Debug_Print(" ReturnStack.Push " + _
                        '            "  Line=" + LineInExecution.ToString + _
                        '            "  StackPeek=" + ReturnStack.Peek.ToString + _
                        '            "  StackCount=" + ReturnStack.Count.ToString)
                    End If
                    GotoLine = line
                    ExecutionThread_Start()
                End If
                Return
            End If
        Next
        ' ------------------------------------------------------ reinitialize the autorepeat status
        PollKeysRepeatStatus = 0
        KeyEventsStackIndex = 99999
    End Sub

    Private KeyEventsStackIndex As Int32
    Friend Sub ClearKeyEventsStackIndex()
        KeyEventsStackIndex = 99999
    End Sub

    ' =============================================================================================
    '  Test the Slot_ExternalCommands
    ' =============================================================================================
    Private Sub ExternalCommandsSlot_Clear()
        Dim Slot As Int32 = CInt(GetNumericUserVariable("Slot_ExternalCommands"))
        If Slot > 0 Then StringSlots.WriteString(Slot, "")
    End Sub

    Private Sub ExternalCommands()
        If Not Running Then Return
        ' --------------------------------------------------------------------- get the slot
        Dim Slot As Int32 = CInt(GetNumericUserVariable("Slot_ExternalCommands"))
        If Slot <= 0 Then Return
        Dim StrCmd As String = StringSlots.ReadString(Slot)
        '
        If StrCmd = "" Or StrCmd = "Executing" Then Return
        '
        StringSlots.WriteString(Slot, "Executing")
        '
        String_ExternalCommand = StrCmd
        ' ---------------------------------------------------------------------------------
        '  EXEC BUTTONS (if the label Event_ExternalCommands is not declared)
        ' --------------------------------------------------------------------------------- 
        Dim LabelLine As Int32 = RTB.FindLabel(RTB_Lines, "Event_ExternalCommands")
        If LabelLine < 0 Then
            Dim i As Int32 = GetButtonByIdentifierOrName(StrCmd)
            If i > 0 Then
                ExecButton(Buttons(i - 1))
            End If
            Return
        End If
        ' --------------------------------------------------------------------------------- 
        '  EXEC the label Event_ExternalCommands (if the label is declared)
        ' ---------------------------------------------------------------------------------
        ' --------------------------------------------------------------------- get the return line
        Dim ReturnLine As Int32 = GetReturnLineNumber(LabelLine)
        If ReturnLine < 0 Then Return
        '
        ' ---------------------------------------------------------------------
        '  Call the event line
        ' ---------------------------------------------------------------------
        Static LastStackCount As Int32 = 0
        ExecutionThread_Stop()

        ' --------------------------------------------------------------- debug
        'Debug.Print("  LabelLine=" + LabelLine.ToString + _
        '            "  ReturnLine=" + ReturnLine.ToString + _
        '            "  LineInExec=" + LineInExecution.ToString + _
        '            "  StackPeek=" + PeekFromReturnStack.ToString + _
        '            "  StackCount=" + ReturnStack.Count.ToString + _
        '            "  LastStackCount=" + LastStackCount.ToString)

        ' ----------------------------------------------------------------- OK
        If ReturnStack.Count <= LastStackCount Or LastStackCount = 0 Then
            LastStackCount = ReturnStack.Count
            ReturnStack.Push(LineInExecution)
        End If

        GotoLine = LabelLine
        ExecutionThread_Start()
    End Sub

    Private Function PeekFromReturnStack() As Int32
        If ReturnStack.Count = 0 Then Return -1
        Return ReturnStack.Peek
    End Function

    ' =============================================================================================
    '  EXECUTION DELAY
    ' =============================================================================================
    Private InstructionsCounter As Int32 = 0
    Private InstructionsCounterMax As Int32
    Private ExecutionDelayMillisec As Int32
    Private Sub SetExecutionDelayParams(ByVal n As Int32)
        If n = 0 Then n = tkbar_Speed.Value
        If n > 9 Then n = 9
        Select Case n
            Case 1 : ExecutionDelayMillisec = 1000 : InstructionsCounterMax = 0
            Case 2 : ExecutionDelayMillisec = 500 : InstructionsCounterMax = 0
            Case 3 : ExecutionDelayMillisec = 200 : InstructionsCounterMax = 0
            Case 4 : ExecutionDelayMillisec = 100 : InstructionsCounterMax = 0
            Case 5 : ExecutionDelayMillisec = 50 : InstructionsCounterMax = 0
            Case 6 : ExecutionDelayMillisec = 10 : InstructionsCounterMax = 0
            Case 7 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 0
            Case 8 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 10
            Case 9 : ExecutionDelayMillisec = 1 : InstructionsCounterMax = 100
        End Select
    End Sub
    Private Sub ShowExecutionDelayText(ByVal n As Int32)
        Dim s As String = ""
        Select Case n
            Case 1 : s = "1 instructions per second - CPU usage very low"
            Case 2 : s = "2 instructions per second - CPU usage very low"
            Case 3 : s = "5 instructions per second - CPU usage very low"
            Case 4 : s = "10 instructions per second - CPU usage very low"
            Case 5 : s = "20 instructions per second - CPU usage very low"
            Case 6 : s = "100 instructions per second - CPU usage very low"
            Case 7 : s = "1000 instructions per second - 1 mS each instruction - CPU usage low"
            Case 8 : s = "10 000 instructions per second - 100 uS each instruction - CPU usage about 2%"
            Case 9 : s = "100 000 instructions per second - 10 uS each instruction (if possible) - High CPU usage"
        End Select
        SetStatusLabelFontProportional()
        StatusLabel1.Text = s
    End Sub
    Private Sub ExecutionDelay_Variable()
        If EventTimer_Working Then Return
        If SingleStep Then Return
        InstructionsCounter += 1
        If InstructionsCounter >= InstructionsCounterMax Then
            InstructionsCounter = 0
            ExecutionDelayVariable_WaitSeconds(ExecutionDelayMillisec / 1000)
        End If
    End Sub
    Private Sub ExecutionDelay_Minimum()
        InstructionsCounter += 1
        If InstructionsCounter >= InstructionsCounterMax Then
            InstructionsCounter = 0
            Thread.Sleep(1)
        End If
    End Sub


    ' =======================================================================================================
    '  SELECT LINE
    ' =======================================================================================================
    Private Delegate Sub ScrollToLine_Delegate(ByVal line As Int32)
    Private Sub ScrollToLine_ThreadSafe(ByVal line As Int32)
        If InvokeRequired Then
            Invoke(New ScrollToLine_Delegate(AddressOf ScrollToLine_ThreadSafe), line)
        Else
            Dim OldEventsAreEnabled As Boolean = EventsAreEnabled
            EventsAreEnabled = False
            ScrollToLine(line)
            EventsAreEnabled = OldEventsAreEnabled
        End If
    End Sub

    Private Sub ScrollToLine(ByVal line As Int32)
        If line < 0 Then line = 0
        RTB.Select(RTB.GetFirstCharIndexFromLine(line), 0)
    End Sub

    Private Delegate Sub ScrollToCenterSelectedLine_Delegate(ByVal line As Int32)
    Private Sub ScrollToCenterSelectedLine_ThreadSafe(ByVal line As Int32)
        If InvokeRequired Then
            BeginInvoke(New ScrollToCenterSelectedLine_Delegate(AddressOf ScrollToCenterSelectedLine_ThreadSafe), line)
        Else
            Dim OldEventsAreEnabled As Boolean = EventsAreEnabled
            EventsAreEnabled = False
            RTB.ScrollToCenterLine(LineInExecution)
            EventsAreEnabled = OldEventsAreEnabled
        End If
    End Sub


    ' =============================================================================================
    '   TIMERS
    ' =============================================================================================
    Private Sub Timer100ms_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer100ms.Tick
        ' ------------------------------------------------------------------------------- DEBUG INFO
        If Running Or Debugging Then
            ShowDebugInfo()
        End If
        ' ------------------------------------------------------------------------------- Running-Lines Hilight and Scroll 
        If Running Then
            If chk_ScrollEnabled.Checked Then
                If LineInExecution >= 0 Then
                    If tkbar_Speed.Value < 5 Then
                        ' ------------------------------------------------------------------- center the execution line
                        RTB.ScrollToCenterLine(LineInExecution)
                        ' ------------------------------------------------------------------- select
                        RTB.Select(RTB.GetFirstCharIndexFromLine(LineInExecution), 1)
                        ' ------------------------------------------------------------------- show running lines
                        RTB.Hilighter_ShowAllBufferedLines()
                    Else
                        ScrollToLine(LineInExecution)
                        RTB.Select(RTB.GetFirstCharIndexFromLine(LineInExecution), 1)
                        RTB.Hilighter_ShowAllBufferedLines()
                    End If
                End If
            Else
                ' ----------------------------------------------------------------------- show running lines without scrolling
                Dim l As Int32 = LineInExecution
                If l >= RTB.GetFirstVisibleLine And l < RTB.GetLastVisibleLine Then
                    RTB.Select(RTB.GetFirstCharIndexFromLine(l), 1)
                Else
                    RTB.SelectionLength = 0
                End If
                ' ----------------------------------------------------------------------- Hilighter show all buffered lines
                RTB.Hilighter_ShowAllBufferedLines()
            End If
        End If
    End Sub

    Private Sub ShowDebugInfo()
        ' ----------------------------------------------------------- speed tester
        'Dim sw As Stopwatch = New Stopwatch
        'sw.Reset()
        'sw.Start()
        ' ----------------------------------------------------------- find mouse position
        Dim MousePos As Point
        MousePos = RTB.PointToClient(Cursor.Position)
        If Not RTB.ClientRectangle.Contains(MousePos) Then Return
        ' ----------------------------------------------------------- find pointed word
        Dim CharIndex As Int32
        CharIndex = RTB.GetCharIndexFromPosition(MousePos)

        Dim p As Point = RTB.GetPositionFromCharIndex(CharIndex)
        If Math.Abs(p.X - MousePos.X) > 20 Or Math.Abs(p.Y - MousePos.Y) > 20 Then
            lbl_DebugText.Visible = False
            Return
        End If
        ' ----------------------------------------------------------- ensure updated RTB_Text
        RTB_Text = RTB.Text
        ' ----------------------------------------------------------- 
        Dim start, length As Int32
        FindWordPointers_ShortWords(RTB_Text, CharIndex, start, length)
        If start < 0 Then Return
        Dim s As String = Mid(RTB_Text, start + 1, length)

        'StatusLabel1.Text = s 
        'StatusLabel1.Text = stringToEnd
        'StatusLabel1.Text = sw.Elapsed.TotalMilliseconds.ToString("0.0", GCI)

        ' ----------------------------------------------------------- get value from variables
        Dim value As String = ""
        If IsNumericUserVariable(s) Then
            value = GetNumericUserVariable(s).ToString(GCI)
        ElseIf IsNumericShortVariable(s) Then
            value = GetNumericShortVariable(s).ToString(GCI)
        ElseIf IsStringUserVariable(s) Then
            value = GetStringUserVariable(s).ToString
            value = """" + value + """"
        ElseIf IsStringShortVariable(s) Then
            value = GetStringShortVariable(s).ToString
            value = """" + value + """"
        Else
            '-------------------------------------------------------- get value from functions
            s = GetTextToEndOfFormula(RTB_Text, start)
            '-------------------------------------------------------- add brackets to Slot function
            If s.Trim.StartsWith("Slot") Then
                Dim n As Int32 = s.IndexOf("=")
                If n > 0 AndAlso Not s.Substring(0, n).Contains("(") Then
                    s = "Slot(" + Mid(s, 5).Trim
                    If n > 0 Then s = Strings.Left(s, n).Trim + ")"
                End If
            End If
            '-------------------------------------------------------- clean s
            s = s.Replace("Print", " ")
            s = ReplaceMultipleSpacesAndTabAndTrim(s)
            If s.Length > 1 Then
                If s.StartsWith("+") Then s = s.Substring(2)
                If s.StartsWith("=") Then s = s.Substring(2)
                If s.StartsWith("&") Then s = s.Substring(2)
                'StatusLabel1.Text = s
                ' ------------------------------------------------------- exclude some functions
                s = s.Replace("SelectFile", "")
                s = s.Replace("SelectFolder", "")
                '-------------------------------------------------------- get value from functions
                If IsValidString_AutoQuoting(s) Then
                    value = EvalString_AutoQuoting(s)
                    value = """" + value + """"
                ElseIf IsValidBoolean(s) Then
                    value = EvalBoolean(s).ToString
                ElseIf IsValidDouble(s) Then
                    value = EvalDouble(s).ToString(GCI)
                End If
            End If
        End If
        ' ----------------------------------------------------------- test value
        Dim v As String
        If value <> "" And s.Replace("""", "") <> value.Replace("""", "") Then
            v = s + " = " + value
            ' ------------------------------------------------------- font size
            Dim newsize As Single = RTB.ZoomFactor * 15
            If newsize < 14.25 Then newsize = 14.25
            If newsize <> lbl_DebugText.Font.SizeInPoints Then
                lbl_DebugText.Font = New Font("Arial", newsize)
            End If
            ' ------------------------------------------------------- position
            MousePos.Offset(30, 15)
            If MousePos.Y + lbl_DebugText.Height > RTB.Height - 10 Then
                MousePos.Y = RTB.Height - lbl_DebugText.Height - 10
                If MousePos.Y < 10 Then MousePos.Y = 10
            Else
                If MousePos.X + lbl_DebugText.Width > RTB.Width - 10 Then
                    MousePos.X = RTB.Width - lbl_DebugText.Width - 10
                    If MousePos.X < 10 Then MousePos.X = 10
                End If
            End If
            lbl_DebugText.Location = MousePos
            lbl_DebugText.Visible = True
        Else
            v = ""
            lbl_DebugText.Visible = False
        End If
        ' ----------------------------------------------------------- print value if changed
        Static str As String
        If v <> str Then
            str = v
            ' limit length because too long strings are not visualized
            str = str.Replace("&", "&&")
            lbl_DebugText.Text = Strings.Left(str, 10000)
        End If
        ' ----------------------------------------------------------- speed tester (about 1mS)
        'StatusLabel1.Text = sw.Elapsed.TotalMilliseconds.ToString("0.0", GCI)
    End Sub

    Private Sub Timer50ms_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer50ms.Tick
        If Running Then
            ExecButtonsFromSlots()
            ExecFlashingButtons()
        Else
            ' ------------------------------------------------------- Enable/Disable buttons
            chk_ControlsBack.Enabled = RTB.Editor_CanHistoryBack
            chk_ControlsForward.Enabled = RTB.Editor_CanHistoryForward
            chk_ControlsUndo.Enabled = RTB.Editor_CanUndo
            chk_ControlsRedo.Enabled = RTB.Editor_CanRedo
            ' ------------------------------------------------------- Enable/Disable tools
            chk_HistoryBack.Enabled = RTB.Editor_CanHistoryBack
            chk_HistoryForward.Enabled = RTB.Editor_CanHistoryForward
            chk_Undo.Enabled = RTB.Editor_CanUndo
            chk_Redo.Enabled = RTB.Editor_CanRedo
            ' ------------------------------------------------------- Load and Save buttons backcolor
            If RTB.TextMustBeSaved Then
                chk_ControlsLoad.BackColor = Color.Orange
                chk_ControlsSave.BackColor = Color.Orange
            Else
                chk_ControlsLoad.BackColor = Color.Moccasin
                chk_ControlsSave.BackColor = Color.Moccasin
            End If
        End If
    End Sub

    Private Sub Timer20ms_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer20ms.Tick
        If Form.ActiveForm IsNot Nothing Or GlobalKeysAreEnabled Then
            PollKeys()
        End If
        If EvalFunctions.WmpIsPlaying Then
            EvalFunctions.WmpMediaPosition = WMP.Ctlcontrols.currentPosition
        End If
        ExternalCommands()
    End Sub

    Private LineInExecution_OLD As Int32 = -1
    Private Sub Timer_Fast_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerFast.Tick
        ' ------------------------------------- Flickering booster (to test ListViewFlickerFree)
        'If My.Computer.Keyboard.CapsLock Then
        '    Form_Debug.ListView1.BeginUpdate()
        '    Form_Debug.ListView1.EndUpdate()
        'End If
        ' -------------------------------------------------------------------------------------
        'Text = GetNormalizedCursorX.ToString("0.0", GCI) + "  " + GetNormalizedCursorY.ToString("0.0", GCI)

        ResizeWithCtrlShift()
    End Sub

    Private Resizing As Boolean
    Private StartMousePoint As Point
    Private NewRatio As SizeF = New SizeF(1, 1)
    Private OldRatio As SizeF

    Private Sub ResizeWithCtrlShift()
        If Control.MouseButtons <> Windows.Forms.MouseButtons.None Then
            Return
        End If
        If Control.ModifierKeys = Keys.Control + Keys.Shift Then
            If Resizing Then
                ResizeControlsWithControlShift_By(Cursor.Position.X - StartMousePoint.X, _
                                                  Cursor.Position.Y - StartMousePoint.Y)
                Cursor.Position = StartMousePoint
            Else
                Resizing = True
                NewRatio = myResizer.GetRatio
                StartMousePoint = Cursor.Position
                OldRatio.Width = -1
            End If
        Else
            If Resizing Then
                Resizing = False
            End If
        End If
    End Sub

    Private Sub ResizeControlsWithControlShift_By(ByVal Dx As Int32, ByVal Dy As Int32)
        '
        NewRatio.Width *= 1 + 0.005F * Dx
        NewRatio.Height *= 1 + 0.005F * Dy
        '
        NewRatio.Width = Math.Min(Math.Max(NewRatio.Width, 0.6F), 3)
        NewRatio.Height = Math.Min(Math.Max(NewRatio.Height, 0.65F), 2)
        '
        If NewRatio <> OldRatio Then
            OldRatio = NewRatio
            LockUpdate(Me)
            ' 
            myResizer.ResizeAllControls_FixedRatio(Me.GBox_Controls, NewRatio)
            '
            ResizeControlAndProgramPanels()
            SetButtonsPositions()
            SetVisibleButtons()
            UnlockUpdate()
        End If
    End Sub

    ' ============================================================================================
    '  LOCK DESKTOP UPDATE - very powerful and never flickers
    '  LOCK UPDATE         - use this on forms, otherwise it can flash desktop icons
    '  UNLOCK UPDATE       - use this to terminate the locked section
    ' ============================================================================================
    Private Declare Function LockWindowUpdate Lib "User32" (ByVal hWnd As IntPtr) As Int32
    Private Declare Function GetDesktopWindow Lib "user32" Alias "GetDesktopWindow" () As IntPtr
    Friend Sub LockDesktopUpdate()
        LockWindowUpdate(GetDesktopWindow)
    End Sub
    Friend Sub LockUpdate(ByVal ctrl As Control)
        LockWindowUpdate(ctrl.Handle)
    End Sub
    Friend Sub UnlockUpdate()
        LockWindowUpdate(Nothing)
    End Sub


    ' ===========================================================================================
    '   EVENT TIMER
    ' ===========================================================================================
    Private EventTimer_LockObj As Object = New Object
    Friend EventTimer_StartLine As Int32
    Friend EventTimer_EndLine As Int32
    Private EventTimer_Working As Boolean
    Private EventTimer_StopWatch As Stopwatch = New Stopwatch
    Friend Sub EventTimer_Init()
        Dim n As Int32 = RTB.FindLabel(RTB_Lines, "EventTimer")
        If n >= 0 And n < RTB_Lines.Length Then
            EventTimer_StartLine = n
            For n = n + 1 To RTB_Lines.Length - 1
                Dim l As String = RTB_Lines(n).Trim.ToLower
                If l.StartsWith("return") Then
                    EventTimer_EndLine = n
                    EventTimer_StopWatch.Reset()
                    EventTimer_StopWatch.Start()
                    EventTimer_Working = False
                    Return
                End If
                If l.StartsWith("label") Then
                    Exit For
                End If
            Next
        End If
        EventTimer_StartLine = -1
        EventTimer_EndLine = -1
        EventTimer_StopWatch.Stop()
        EventTimer_StopWatch.Reset()
        EventTimer_Working = False
    End Sub

    Private Function EventTimer_Exec() As Boolean
        If EventTimer_StartLine < 0 Then Return False
        If EventTimer_StopWatch.ElapsedMilliseconds < 100 Then Return False
        '
        SyncLock EventTimer_LockObj
            If EventTimer_Working Then Return False
            EventTimer_Working = True
            ReturnStack.Push(LineInExecution)
            GotoLine = EventTimer_StartLine
            LineInExecution = EventTimer_StartLine
            EventTimer_Exec = True
            Thread.Sleep(1)
            EventTimer_StopWatch.Reset()
            EventTimer_StopWatch.Start()
        End SyncLock
    End Function


    ' =============================================================================================
    '   EXECUTION THREAD
    ' =============================================================================================
    Private TerminateThread As Boolean
    Private ExecutionThread As Thread
    Sub ExecutionThread_Start()
        If ExecutionThread IsNot Nothing Then Return
        ExecutionThread = New Thread(AddressOf MainExecutionThread)
        ExecutionThread.Priority = System.Threading.ThreadPriority.AboveNormal
        ' ----------------------------------------------------------------------------
        '  Setting the Thread as STA it could be possible to use the OpenFileDialog 
        '  But the STA could change completely the program execution
        '  Maybe we could try it but testing exensively because can be very dangerous
        ' ----------------------------------------------------------------------------
        'ExecutionThread.SetApartmentState(ApartmentState.STA)
        ' ----------------------------------------------------------------------------
        ' Exception of type 'System.OutOfMemoryException' was thrown.
        ' show also C:\Livio\_HELP\01 - Visual Basic 2008 - KnowHow\003 Theremino SLOTS and STRINGS
        TerminateThread = False
        ExecutionThread.Start()
    End Sub

    Sub ExecutionThread_Stop()
        If ExecutionThread Is Nothing Then Return
        ' --------------------------------------------- try to join the thread
        TerminateThread = True
        ExecutionThread.Join(10)
        Try
            ' --------------------------------------------- test 
            For i As Int32 = 1 To 20
                If Not ExecutionThread.IsAlive Then Exit For
                Threading.Thread.Sleep(10)
                Application.DoEvents()
            Next
            ' --------------------------------------------- eventually abort
            If ExecutionThread.IsAlive Then
                'MessageBox.Show("ExecutionThread not closed correctly.", _
                '                "Message from Automation", _
                '                MessageBoxButtons.OK, MessageBoxIcon.Warning)
                ExecutionThread.Abort()
            End If
        Catch
        End Try
        ' ---------------------------------------------
        ExecutionThread = Nothing
    End Sub

    Sub MainExecutionThread()
        If RTB_Lines Is Nothing Then Return
        If RTB_Lines.Length = 0 Then Return
        Do
            RTB_Exec()
        Loop Until TerminateThread
        TerminateThread = False
    End Sub


    ' =============================================================================================
    '  EXECUTION
    ' =============================================================================================
    Private ReturnStack As Stack(Of Integer) = New Stack(Of Integer)
    Private ForNextStack As Stack(Of Integer) = New Stack(Of Integer)
    Friend JumpingFromNEXT As Boolean = False
    Private JumpingFromNext_LineIndex As Int32
    'Private sw As Stopwatch = New Stopwatch ' speed tester

    Friend Sub RTB_Exec()
        '
        If Not Running Then Thread.Sleep(1) : Return
        '
        ' ---------------------------------------------------------------- GOTO LINE
        If GotoLine >= 0 Then
            LineInExecution = GotoLine
            GotoLine = -1
            SkipEmptyLines(LineInExecution)
        Else
            If LineInExecution > RTB_Lines.Length - 1 Then
                LineInExecution = 0
            End If
            ' ------------------------------------------------------------ TEST FOR BREAKPOINT
            If Debugging Then
                If RTB_Lines(LineInExecution).ToLower.Contains("breakpoint") Then
                    If Not RTB_Lines(LineInExecution).TrimStart.StartsWith("'") Then
                        LineBeforeRun = -1
                        ScrollToCenterSelectedLine_ThreadSafe(LineInExecution)
                        ScrollToLine_ThreadSafe(LineInExecution)
                        StopRunning_DontRestoreScrollAndDontCallLabel_ThreadSafe()
                        Exit Sub
                    End If
                End If
            End If
        End If

        '
        ' ---------------------------------------------------------------- add the line number to ExecutedLines
        RTB.Hilighter_AddExecutedLine(LineInExecution)

        '
        ' ---------------------------------------------------------------- EXEC THE LINE
        ExecTheLine(LineInExecution)

        '
        ' ---------------------------------------------------------------- do not increment the line
        If TerminateThread Then Return
        '
        ' ---------------------------------------------------------------- NEXT LINE
        LineInExecution += 1
        SkipEmptyLines(LineInExecution)

        ' ---------------------------------------------------------------- TEST FOR BREAKPOINT (patch for return)
        '  This is a patch to test breakpoint after a return from gosub
        If Debugging Then
            If RTB_Lines(LineInExecution).ToLower.Contains("breakpoint") Then
                If Not RTB_Lines(LineInExecution).TrimStart.StartsWith("'") Then
                    LineBeforeRun = -1
                    ScrollToCenterSelectedLine_ThreadSafe(LineInExecution)
                    ScrollToLine_ThreadSafe(LineInExecution)
                    StopRunning_DontRestoreScrollAndDontCallLabel_ThreadSafe()
                    Exit Sub
                End If
            End If
        End If
        '
        ' ---------------------------------------------------------------- SINGLE STEP
        If SingleStep Then
            SingleStep = False
            Exit Sub
        End If
        '
        ' ---------------------------------------------------------------- TEST THE PAUSE BUTTON
        TestPauseButton()
        '
        ' ---------------------------------------------------------------- WAIT THE EXECUTION DELAY
        ExecutionDelay_Variable()
        '
        ' ---------------------------------------------------------------- speed tester
        'Print_Message_ThreadSafe(sw.Elapsed.TotalMilliseconds.ToString)
        'sw.Reset()
        'sw.Start()
    End Sub

    Private Sub TestPauseButton()
        If PauseButtonSlot > 0 Then
            If PauseSlotActive() Then
                Print_Message_ThreadSafe(" WARNING : Pause button is pressed (verify the Slot " + PauseButtonSlot.ToString + ")", False)
                SewThreadPaused = True
                PauseLedsON()
                Dim FlashCounter As Single
                Dim FlashIncrementDirection As Int32 = 1
                Do
                    ' ---------------------------------------------------- Flash the output leds
                    If PauseButtonOutputSlotsFrequency > 0 Then
                        Thread.Sleep(10)
                        FlashCounter += FlashIncrementDirection * PauseButtonOutputSlotsFrequency / 50.0F
                        If FlashCounter > 1 Then
                            PauseLedsON()
                            FlashIncrementDirection = -FlashIncrementDirection
                        End If
                        If FlashCounter < 0 Then
                            PauseLedsOFF()
                            FlashIncrementDirection = -FlashIncrementDirection
                        End If
                    End If
                    ' ---------------------------------------------------- Test the Pause Slot and exit
                    If Not PauseSlotActive() Then
                        Print_Message_ThreadSafe("", False)
                        PauseLedsOFF()
                        Exit Do
                    End If
                Loop
                SewThreadPaused = False
            End If
        End If
    End Sub

    Private Function PauseSlotActive() As Boolean
        If PauseButtonSlotDirectionPositive Then
            Return Slots.ReadSlot(PauseButtonSlot) > PauseButtonSlotTripValue
        Else
            Return Slots.ReadSlot(PauseButtonSlot) < PauseButtonSlotTripValue
        End If
    End Function

    Private Sub PauseLedsON()
        For i As Int32 = 0 To PauseButtonOutputSlots.Length - 1
            Slots.WriteSlot(PauseButtonOutputSlots(i), PauseButtonOutputValues(i))
        Next
    End Sub

    Private Sub PauseLedsOFF()
        For i As Int32 = 0 To PauseButtonOutputSlots.Length - 1
            Slots.WriteSlot(PauseButtonOutputSlots(i), 0)
        Next
    End Sub

    Private Sub SkipEmptyLines(ByRef i As Int32)
        For j As Int32 = 0 To RTB_Lines.Length - 1
            If Not LineIsEmptyOrComment(i) Then Exit For
            i += 1
            If i > RTB_Lines.Length - 1 Then i = 0
        Next
    End Sub

    Private Function LineIsEmptyOrComment(ByVal index As Int32) As Boolean
        If index < 0 Then Return True
        If index >= RTB_Lines.Length Then Return True
        Dim l As String = RTB_Lines(index).Trim
        If l = "" Then Return True
        If l.StartsWith("'") AndAlso Not l.ToLower.Contains("breakpoint") Then Return True
        Return False
    End Function


    ' =============================================================================================
    '  EXEC THE LINE
    ' =============================================================================================
    Friend Sub ExecTheLine(ByVal PC As Int32, Optional ByVal line As String = "")
        ' ----------------------------------------------------------------- Tokenize to array of keywords
        Dim sa() As String
        If line <> "" Then
            sa = RTB.Tokenize(line.Trim)
        Else
            sa = RTB.Tokenize(RTB_Lines(PC).Trim)
        End If
        ' ----------------------------------------------------------------- if empty line return
        If sa.Length = 0 Then ExecutionDelay_Minimum() : Return
        '
        Select Case sa.Length
            Case 1
                Select Case sa(0).ToLower
                    Case "beep"
                        Beep_RepetitionLimited(100)
                    Case "else"
                        Dim n As Int32 = FindEndif()
                        If n >= 0 And n < RTB_Lines.Length Then
                            GotoLine = n
                            LineInExecution = n - 1
                        End If
                    Case "caseelse"
                        Dim n As Int32 = FindEndselect()
                        If n >= 0 And n < RTB_Lines.Length Then
                            GotoLine = n
                            LineInExecution = n
                        End If
                    Case "exit"
                        Dim n As Int32 = FindNext(1)
                        If n >= 0 And n < RTB_Lines.Length Then
                            GotoLine = n + 1
                            LineInExecution = n
                            ForNextStack.Pop()
                        End If
                    Case "return"
                        If ReturnStack.Count > 0 Then
                            Dim n As Int32 = ReturnStack.Pop
                            If n >= 0 And n < RTB_Lines.Length Then
                                '
                                TrimTheForNextStack_ByReturn(LineInExecution)
                                '
                                GotoLine = n
                                LineInExecution = n - 1
                            End If
                            If EventTimer_Working Then
                                EventTimer_Working = False
                            End If
                        Else
                            ' ------------------------------------- if can not RETURN then
                            If SingleStep Then
                                LineInExecution -= 1
                            Else
                                If EventStopLabelExecuted Then
                                    ' ----------------------------- exec a STOP
                                    StopRunning_ThreadSafe()
                                    LineInExecution -= 1
                                Else
                                    ' ----------------------------- or wait forever
                                    Wait_Forever()
                                End If
                            End If
                        End If
                    Case "next"
                        If ForNextStack.Count > 0 Then
                            Dim n As Int32 = ForNextStack.Peek
                            If n >= 0 And n < RTB_Lines.Length Then
                                JumpingFromNEXT = True
                                JumpingFromNext_LineIndex = LineInExecution
                                GotoLine = n
                                LineInExecution = n - 1
                            End If
                        End If
                    Case "stop"
                        If SingleStep Then
                            LineInExecution -= 1
                        Else
                            Wait_Forever()
                        End If
                    Case "end"
                        StopRunning_DontCallLabel_ThreadSafe()
                        LineInExecution -= 1
                    Case "sewabort"
                        SewAbort()
                    Case Else
                        If RTB.LABELS_WITHOUT_GOSUB Then
                            ' ------------------------------------------------------ GOSUB WITH PARAMETERS - WITHOUT GOSUB
                            Dim n As Int32 = GetLabelLine(sa(0))
                            ' ------------------------------------------------------ Test the label-name without parameters 
                            If n < 0 Then
                                ' -------------------------------------------------- extract params and remove them from the name
                                Dim params As String() = ExtractFunctionParams(sa(0))
                                ' -------------------------------------------------- find label
                                n = GetLabelLine(sa(0))
                                If n >= 0 And n < RTB_Lines.Length Then
                                    ' ---------------------------------------------- assign params
                                    AssignParamsToFunctionVars(params, n)
                                End If
                            End If
                            ' ------------------------------------------------------ call the function
                            If n >= 0 And n < RTB_Lines.Length Then
                                ReturnStack.Push(PC + 1)
                                GotoLine = n
                                LineInExecution = n
                            End If
                        End If
                End Select
            Case 2
                Select Case sa(0).ToLower
                    Case "beep"
                        PlayBeepAsync(0, 0, sa(1))
                    Case "com"
                        If sa(1).ToLower = "close" Then
                            COM_Close()
                        ElseIf sa(1).ToLower = "discardinbuffer" Then
                            COM_DiscardInBuffer()
                        ElseIf sa(1).ToLower = "discardoutbuffer" Then
                            COM_DiscardOutBuffer()
                        ElseIf sa(1).ToLower = "enabledtr" Then
                            COM_EnableDTR()
                        ElseIf sa(1).ToLower = "enablerts" Then
                            COM_EnableRTS()
                        ElseIf sa(1).ToLower = "disabledtr" Then
                            COM_DisableDTR()
                        ElseIf sa(1).ToLower = "disablerts" Then
                            COM_DisableRTS()
                        End If
                    Case "controls"
                        If sa(1).ToLower.StartsWith("opentextbox") Or _
                           sa(1).ToLower = "closetextbox" Or _
                           sa(1).ToLower = "cleartextbox" Then
                            SetTextBox_ThreadSafe(sa(1))
                        End If
                    Case "exit"
                        Dim n As Int32 = CInt(Val(sa(1)))
                        Dim n2 As Int32 = FindNext(n)
                        If n2 >= 0 And n2 < RTB_Lines.Length Then
                            GotoLine = n2 + 1
                            LineInExecution = n2
                            For i As Int32 = 1 To n
                                If ForNextStack.Count > 0 Then
                                    ForNextStack.Pop()
                                End If
                            Next
                        End If
                    Case "gosub"
                        ' ------------------------------------------------- GOSUB WITH PARAMETERS
                        ' -------------------------------------------------- extract params and remove them from the name
                        Dim params As String() = ExtractFunctionParams(sa(1))
                        ' -------------------------------------------------- find label
                        Dim n As Int32 = GetLabelLine(sa(1))
                        If n >= 0 And n < RTB_Lines.Length Then
                            ' ---------------------------------------------- assign params
                            AssignParamsToFunctionVars(params, n)
                            ' ---------------------------------------------- normal gosub
                            ReturnStack.Push(PC + 1)
                            GotoLine = n
                            LineInExecution = n
                        End If
                    Case "goto"
                        Dim n As Int32 = RTB.FindLabel(RTB_Lines, sa(1))
                        If n >= 0 And n < RTB_Lines.Length Then
                            GotoLine = n
                            LineInExecution = n
                            TrimTheForNextStack_ByGoto(PC, n)
                        End If
                    Case "if"
                        If Not EvalBoolean(sa(1)) Then
                            Dim n As Int32 = FindElseOrEndif()
                            If n >= 0 And n < RTB_Lines.Length Then
                                GotoLine = n + 1
                                LineInExecution = n
                            End If
                        End If
                    Case "select"
                        Dim n As Int32
                        ' ------------------------------------------
                        If IsNumeric(sa(1)) Then
                            Dim d As Double = EvalDouble(sa(1))
                            n = FindCaseNumeric(d)
                        Else
                            Dim s As String = EvalString(sa(1))
                            n = FindCaseString(s)
                        End If
                        ' ------------------------------------------
                        If n >= 0 And n < RTB_Lines.Length Then
                            GotoLine = n + 1
                            LineInExecution = n
                        Else
                            n = FindCaseElse()
                            If n >= 0 And n < RTB_Lines.Length Then
                                GotoLine = n + 1
                                LineInExecution = n
                            Else
                                n = FindEndselect()
                                If n >= 0 And n < RTB_Lines.Length Then
                                    GotoLine = n
                                    LineInExecution = n
                                End If
                            End If
                        End If
                    Case "case"
                        Dim n As Int32 = FindEndselect()
                        If n >= 0 And n < RTB_Lines.Length Then
                            GotoLine = n
                            LineInExecution = n
                        End If
                    Case "load"
                        If sa(1).ToLower.Trim.StartsWith("slots") Then
                            Dim n() As Double = ExtractNumericParams(sa(1), 3)
                            If n.Length = 2 Then
                                If n(0) < 0 Then n(0) = 0
                                If n(0) > 999 Then n(0) = 999
                                If n(1) < 0 Then n(1) = 0
                                If n(1) > 999 Then n(1) = 999
                                LoadSlots(CInt(n(0)), CInt(n(1)))
                            Else
                                LoadSlots(0, 999)
                            End If
                        Else
                            Select Case sa(1).ToLower.Trim
                                Case "vars"
                                    LoadVars()
                                Case Else
                                    If sa(1).ToLower.Trim.StartsWith("openapps") Then
                                        OpenAllThereminicApps()
                                    ElseIf sa(1).ToLower.Trim.StartsWith("closeapps") Then
                                        If sa(1).ToLower.Trim = "closeapps" Then
                                            ' --------------------------------------------------- CLOSE ALL OPENED PROCESSES 
                                            CloseAllOpenedProcesses()
                                        Else
                                            Dim fname As String = sa(1).Substring(9).Trim.Replace("""", "")

                                            If fname.ToLower = "windows" Then
                                                ' ----------------------------------------------- CLOSE WINDOWS
                                                StopRunning_DontCallLabel_ThreadSafe()
                                                LineInExecution -= 1
                                                Beep()
                                                ForceWindowsShutDownAndPowerOff()
                                            Else
                                                ' ----------------------------------------------- CLOSE APP BY FILENAME
                                                CloseAppByFilename(fname)
                                            End If
                                        End If
                                    ElseIf sa(1).ToLower = "closeall" Then
                                        ' ------------------------------------------------------- CLOSE ALL OPENED PROCESSES AND AUTOMATION TOO
                                        CloseAllOpenedProcesses()
                                        If Not KeyPressedNow(Keys.ControlKey) Then CloseApplication_ThreadSafe()
                                    Else
                                        ' ------------------------------------------------------- LOAD MEDIA 
                                        Load_Media_ThreadSafe(sa(1).Trim)
                                    End If
                            End Select
                        End If
                    Case "presskeys"
                        ExecutePressKeys(EvalString_AutoQuoting(sa(1)))
                    Case "sendkeys"
                        ExecuteSendKeys(EvalString_AutoQuoting(sa(1)))
                    Case "print"
                        Print_Message_ThreadSafe(EvalString(sa(1)), True)
                    Case "save"
                        Select Case sa(1).ToLower
                            Case "slots"
                                SaveSlots()
                            Case "vars"
                                SaveVars()
                        End Select
                    Case "tts"
                        Select Case sa(1).ToLower
                            Case "stop"
                                TTS_Stop()
                            Case "pause"
                                TTS_Pause()
                            Case "resume"
                                TTS_Resume()
                        End Select
                    Case "varsfromfile"
                        Dim s As String = sa(1)
                        If Not IO.File.Exists(s) Then
                            s = Application.StartupPath + "\Files\" + sa(1)
                        End If
                        If IO.File.Exists(s) Then
                            Dim err As String = VarsFromFile(s)
                            If err <> "" Then
                                SetTextBox_ThreadSafe("OpenTextBox")
                                Print_Message_ThreadSafe(vbCrLf + "Command ""VarsFromFile""" + vbCrLf + _
                                                         "-----------------------------------------" + vbCrLf + err + _
                                                         "-----------------------------------------" + vbCrLf, True)
                                StopRunning_DontCallLabel_ThreadSafe()
                                LineInExecution -= 1
                            End If
                        Else
                            Print_Message_ThreadSafe(" WARNING : File not found : """ + s + """", False)
                            MessageBox.Show("File not found : """ + s + """", "Message from Automation", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            Print_Message_ThreadSafe("", False)
                            StopRunning_DontCallLabel_ThreadSafe()
                            LineInExecution -= 1
                        End If
                    Case "wait"
                        If Not SingleStep Then
                            If IsValidBoolean(sa(1)) Then
                                Do
                                    If EventTimer_Exec() Then Exit Do
                                    Thread.Sleep(10)
                                    TestPauseButton()
                                Loop Until EvalBoolean(sa(1)) OrElse TerminateThread = True OrElse Running = False
                            End If
                        End If
                    Case "window"
                        Select Case sa(1).ToLower
                            Case "setfocus"
                                SetViewMode_ThreadSafe(ViewModes.SetFocus)
                            Case "minsize"
                                SetViewMode_ThreadSafe(ViewModes.MinSize)
                            Case "sizable"
                                SetViewMode_ThreadSafe(ViewModes.Sizable)
                            Case "maximized"
                                SetViewMode_ThreadSafe(ViewModes.Maximized)
                            Case "fullscreen"
                                SetViewMode_ThreadSafe(ViewModes.FullScreen)
                        End Select
                End Select
            Case 3
                Select Case sa(0).ToLower
                    Case "beep"
                        PlayBeepAsync(EvalDouble(sa(1)), EvalDouble(sa(2)), "")
                    Case "button"
                        If sa(2).ToLower = "enabled" Or sa(2).ToLower = "disabled" Then
                            SetButton_ThreadSafe(sa(1), sa(2).ToLower, LineInExecution)
                        End If
                    Case "com"
                        If sa(1).ToLower = "writestring" Then
                            COM_WriteString(EvalString_AutoQuoting(sa(2)))
                        ElseIf sa(1).ToLower = "writestringhex" Then
                            COM_WriteStringHEX(EvalString_AutoQuoting(sa(2)))
                        ElseIf sa(1).ToLower = "writestringdec" Then
                            COM_WriteStringDEC(EvalString_AutoQuoting(sa(2)))
                        ElseIf sa(1).ToLower = "writeline" Then
                            COM_WriteLine(EvalString_AutoQuoting(sa(2)))
                        End If
                    Case "key"
                        If RTB.IsValidKey(sa(1).ToLower) Then
                            SetKeyEvent(sa(1), "Gosub", sa(2))
                        End If
                    Case "option"
                        Select Case sa(1).ToLower
                            Case "globalkeys"
                                Select Case sa(2).ToLower
                                    Case "enabled" : GlobalKeysAreEnabled = True
                                    Case "disabled" : GlobalKeysAreEnabled = False
                                End Select
                            Case "speed"
                                SetNewSpeed_ThreadSafe(EvalDouble(sa(2)))
                            Case "transparency"
                                SetNewTransparency_ThreadSafe(EvalDouble(sa(2)))
                        End Select
                    Case "save"
                        If sa(1).ToLower = "deletefile" Then
                            Dim s As String = EvalString_AutoQuoting(sa(2))
                            If IO.File.Exists(s) Then
                                IO.File.Delete(s)
                            Else
                                s = Application.StartupPath + "\Files\" + s
                                If IO.File.Exists(s) Then
                                    IO.File.Delete(s)
                                End If
                            End If
                        End If
                    Case "tts"
                        Select Case sa(1).ToLower
                            Case "selectvoice"
                                TTS_SelectVoice(EvalString(sa(2)))
                            Case "setvolume"
                                TTS_SetVolume(EvalInt(sa(2)))
                            Case "setspeed"
                                TTS_SetSpeed(EvalInt(sa(2)))
                            Case "speak"
                                TTS_SpeakText(EvalString_AutoQuoting(sa(2)))
                            Case "speakwait"
                                TTS_SpeakText(EvalString_AutoQuoting(sa(2)))
                                Do
                                    If EventTimer_Exec() Then Exit Do
                                    Thread.Sleep(5)
                                    TestPauseButton()
                                Loop Until TTS_SynthesizerReady() OrElse TerminateThread = True OrElse Running = False
                                TTS_Stop()
                        End Select
                    Case "wait"
                        If Not SingleStep Then
                            If sa(1).ToLower = "seconds" Then Wait_Seconds(EvalDouble(sa(2)))
                            If sa(1).ToLower = "button" Then Wait_Button(sa(2))
                            If sa(1).ToLower = "application" Then
                                Dim s As String = EvalString_AutoQuoting(sa(2))
                                If s = "" Then s = sa(2)
                                Wait_Process(s)
                            End If
                        End If
                    Case Else
                        If sa(1) = "=" Then
                            If IsNumericUserVariable(sa(0)) Then SetNumericUserVariable(sa(0), EvalDouble(sa(2)))
                            If IsStringUserVariable(sa(0)) Then SetStringUserVariable(sa(0), EvalString(sa(2)))
                            If IsNumericShortVariable(sa(0)) Then SetNumericShortVar(sa(0), EvalDouble(sa(2)))
                            If IsStringShortVariable(sa(0)) Then SetStringShortVar(sa(0), EvalString(sa(2)))
                        End If
                End Select
            Case 4
                Select Case sa(0).ToLower
                    Case "button"
                        If sa(2).ToLower = "label" Or sa(2).ToLower = "text" Then
                            Dim s As String = EvalString(sa(3))
                            If s = "" Then
                                SetButton_ThreadSafe(sa(1), sa(3), LineInExecution)
                            Else
                                SetButton_ThreadSafe(sa(1), s, LineInExecution)
                            End If
                        End If
                        ' --------------------------------------------------------------------------
                        If sa(2).ToLower = "slot" Then
                            Dim buttonIndex As Int32 = CInt(EvalDouble(sa(1)))
                            If buttonIndex = 0 Then buttonIndex = GetButtonByIdentifier(sa(1))
                            SetButtonSlot_ThreadSafe(buttonIndex, CInt(EvalDouble(sa(3))))
                        End If
                        If sa(2).ToLower = "color" Then
                            Dim buttonIndex As Int32 = CInt(EvalDouble(sa(1)))
                            If buttonIndex = 0 Then buttonIndex = GetButtonByIdentifier(sa(1))
                            If buttonIndex > 0 And buttonIndex <= NBUTTONS Then
                                Dim btn As CheckBox = Buttons(buttonIndex - 1)
                                If btn Is Nothing Then
                                    buttonIndex = CInt(GetNumericVariable(sa(1)))
                                    btn = Buttons(buttonIndex - 1)
                                End If
                                If btn IsNot Nothing Then
                                    If sa(3).Length > 8 And sa(3).ToLower.StartsWith("flashing") Then
                                        ' ------------------------------------------------------------------ Flashing
                                        Dim freq As Single = CSng(Val(sa(3).Substring(8, 1)))
                                        Select Case freq
                                            Case 0 : freq = 4
                                            Case 1 : freq = 1
                                            Case 2 : freq = 1.5
                                            Case 3 : freq = 2
                                            Case 4 : freq = 3
                                            Case 5 : freq = 4.5
                                            Case 6 : freq = 6.5
                                            Case 7 : freq = 9
                                            Case 8 : freq = 13.5
                                            Case 9 : freq = 20
                                        End Select
                                        ButtonFlashingFrequency(buttonIndex - 1) = freq
                                        ButtonFlashingTimer(buttonIndex - 1) = 0
                                        '
                                        Dim sa2() As String = ReplaceMultipleSpacesAndTabAndTrim(sa(3)).Split(" "c)
                                        If sa2.Length = 3 Then
                                            ButtonFlashingColor1(buttonIndex - 1) = ColorFromColorName(sa2(1))
                                            ButtonFlashingColor2(buttonIndex - 1) = ColorFromColorName(sa2(2))
                                            btn.BackColor = ButtonFlashingColor2(buttonIndex)
                                        ElseIf sa2.Length = 7 Then
                                            ButtonFlashingColor1(buttonIndex - 1) = ColorFromColorName(sa2(1) + " " + sa2(2) + " " + sa2(3))
                                            ButtonFlashingColor2(buttonIndex - 1) = ColorFromColorName(sa2(4) + " " + sa2(5) + " " + sa2(6))
                                            btn.BackColor = ButtonFlashingColor2(buttonIndex)
                                        Else
                                            ButtonFlashingFrequency(buttonIndex - 1) = 0
                                        End If
                                    Else
                                        ' ------------------------------------------------------------------ Not flashing
                                        Dim c As Color = ColorFromColorName(sa(3))
                                        If c <> Color.Empty Then
                                            btn.BackColor = c
                                            ButtonBackColor(buttonIndex - 1) = c
                                            CorrectButtonForeColor(btn, buttonIndex)
                                            ButtonFlashingFrequency(buttonIndex - 1) = 0
                                        End If
                                        'SetButton_ThreadSafe(CInt(EvalDouble(sa(1))), sa(3))
                                    End If
                                End If
                            End If
                        End If
                    Case "com"
                        If sa(1).ToLower = "open" Then
                            COM_Open("COM" + EvalDouble(sa(2)).ToString, CInt(EvalDouble(sa(3))))
                        End If
                    Case "controls"
                        If sa(1).ToLower.StartsWith("setcursorpos") Then
                            ' ---------------------------------------------------- cursor position in screen coordimates
                            Dim mousePoint As Point = New Point(EvalInt(sa(2)), EvalInt(sa(3)))
                            ' ---------------------------------------------------- get the screen containing the point
                            Dim s As Screen = Screen.FromPoint(mousePoint)
                            ' ---------------------------------------------------- reverse Y to have the zero down
                            mousePoint.Y = s.Bounds.Height - mousePoint.Y - 1
                            ' ---------------------------------------------------- set the cursor position
                            Cursor.Position = mousePoint
                        End If
                    Case "key"
                        If RTB.IsValidKey(sa(1).ToLower) Then
                            SetKeyEvent(sa(1), sa(2), sa(3))
                        End If
                    Case "save"
                        If sa(1).ToLower = "stringtofile" Then
                            ' --------------------------------------------------
                            Dim s1 As String = EvalString(sa(2))
                            Dim s2 As String = EvalString(sa(3)).Trim
                            ' --------------------------------------------------
                            If s2 <> "" Then
                                Dim dir As String
                                ' ---------------------------------------------- eventually create the "Files" folder
                                dir = Application.StartupPath + "\Files"
                                If Not IO.Directory.Exists(dir) Then
                                    IO.Directory.CreateDirectory(dir)
                                End If
                                ' ---------------------------------------------- eventually create the "Files\Logs" folder
                                dir = Application.StartupPath + "\Files\Logs"
                                If Not IO.Directory.Exists(dir) Then
                                    IO.Directory.CreateDirectory(dir)
                                End If
                                ' ---------------------------------------------- test path
                                dir = IO.Path.GetDirectoryName(s2)
                                If Not IO.Directory.Exists(dir) Then
                                    ' ------------------------------------------ if the path not exists then set the "Files" folder
                                    s2 = IO.Path.GetFileName(s2)
                                    s2 = Application.StartupPath + "\Files\" + s2
                                End If
                                ' ---------------------------------------------- append the string and a NewLine
                                Dim sw As IO.StreamWriter
                                If s1.StartsWith("<ASCII>") Then
                                    s1 = s1.Substring(7)
                                    sw = My.Computer.FileSystem.OpenTextFileWriter(s2, _
                                                                                   True, _
                                                                                   New System.Text.ASCIIEncoding)
                                Else
                                    sw = My.Computer.FileSystem.OpenTextFileWriter(s2, _
                                                                                   True, _
                                                                                   New System.Text.UnicodeEncoding)
                                End If
                                sw.Write(s1 + vbCrLf)
                                sw.Close()
                            End If
                        End If
                    Case "slot"
                        Select Case sa(3).Trim.ToLower
                            Case "reset"
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), NAN_Reset)
                            Case "sleep"
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), NAN_Sleep)
                            Case "recognize"
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), NAN_Recognize)
                            Case "calibrate"
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), NAN_Calibrate)
                            Case Else
                                Slots.WriteSlot(CInt(EvalDouble(sa(1))), CSng(EvalDouble(sa(3))))
                        End Select
                    Case "slottext"
                        StringSlots.WriteString(EvalInt(sa(1)), EvalString_AutoQuoting_ForSlotsText(sa(3)))
                    Case Else
                        If sa(1) = "=" Then
                            If sa(2).ToLower = "input" Then
                                If IsSomeVariable(sa(0)) Then
                                    InputDialog_ThreadSafe(sa(0), EvalString_AutoQuoting(sa(3)), "input")
                                End If
                            ElseIf sa(2).ToLower = "message" Then
                                If IsSomeVariable(sa(0)) Then
                                    InputDialog_ThreadSafe(sa(0), EvalString_AutoQuoting(sa(3)), "message")
                                End If
                            End If
                        End If
                End Select
            Case 5
                Select Case sa(0).ToLower
                    Case "variable"
                        ' -------------------------------------------- Immediate vars execution
                        Select Case sa(1).ToLower
                            Case "numeric"
                                If IsNumericUserVariable(sa(2)) Then SetNumericUserVariable(sa(2), EvalDouble(sa(4)))
                            Case "string"
                                If IsStringUserVariable(sa(2)) Then SetStringUserVariable(sa(2), EvalString_AutoQuoting(sa(4)))
                        End Select
                End Select
            Case 6
                Select Case sa(0).ToLower
                    Case "for"
                        If IsNumericVariable(sa(1)) And sa(2) = "=" And IsValidDouble(sa(3)) And _
                                                        sa(4).ToLower = "to" And IsValidDouble(sa(5)) Then
                            ExecuteFOR(sa(1), _
                                       EvalDouble(sa(3)), _
                                       EvalDouble(sa(5)), _
                                       0, _
                                       PC)
                        End If
                    Case "sewinit"
                        SewInit(EvalInt(sa(1)), EvalInt(sa(2)), EvalInt(sa(3)), EvalInt(sa(4)), EvalInt(sa(5)))
                    Case "sewto"
                        SewTo(EvalDouble(sa(1)), EvalDouble(sa(2)), EvalDouble(sa(3)), EvalDouble(sa(4)), EvalString_AutoQuoting(sa(5)))
                    Case "sewlimits"
                        SewLimits(EvalDouble(sa(1)), EvalDouble(sa(2)), EvalDouble(sa(3)), EvalDouble(sa(4)), EvalDouble(sa(5)))
                End Select
            Case 7
                Select Case sa(0).ToLower
                    '...
                End Select
            Case 8
                Select Case sa(0).ToLower
                    Case "for"
                        If IsNumericVariable(sa(1)) And sa(2) = "=" And IsValidDouble(sa(3)) And _
                                                        sa(4).ToLower = "to" And IsValidDouble(sa(5)) And _
                                                        sa(6).ToLower = "step" And IsValidDouble(sa(7)) Then

                            ExecuteFOR(sa(1), _
                                       EvalDouble(sa(3)), _
                                       EvalDouble(sa(5)), _
                                       EvalDouble(sa(7)), _
                                       PC)
                        End If
                End Select
        End Select
    End Sub


    ' TODO - FOR ERRORS !!!
    ' ===========================================================================================
    '  EXECUTE THE FOR INSTRUCTION
    ' ===========================================================================================
    Private Sub ExecuteFOR(ByVal ControlVariableName As String, _
                           ByVal vInitial As Double, _
                           ByVal vFinal As Double, _
                           ByVal vStep As Double, _
                           ByVal PC As Int32)

        Dim v As Double
        ' --------------------------------------------------- init the control variable value
        If Not JumpingFromNEXT Then
            v = vInitial
            ForNextStack.Push(PC)
        Else
            v = GetNumericVariable(ControlVariableName)
        End If

        ' --------------------------------------------------- set the step sign
        If vStep = 0 Then
            If vFinal > v Then
                vStep = 1
            Else
                vStep = -1
            End If
        End If
        ' --------------------------------------------------- if the step direction is wrong then exit
        If (vStep > 0) = (v > vFinal) And vInitial <> vFinal Then
            Dim n As Int32 = FindNext(1)
            If n >= 0 And n < RTB_Lines.Length Then
                GotoLine = n + 1
                LineInExecution = n
                'ForNextStack.Pop()
            End If
        End If

        ' --------------------------------------------------- 
        If JumpingFromNEXT Then
            If v = vFinal Then
                GotoLine = JumpingFromNext_LineIndex + 1
                LineInExecution = JumpingFromNext_LineIndex
                ForNextStack.Pop()
            End If
            ' ----------------------------------------------- increase the control variable value
            v += vStep
            ' ----------------------------------------------- limit the value to vfinal
            If vStep > 0 Then
                If v > vFinal Then v = vFinal
            Else
                If v <= vFinal Then v = vFinal
            End If
            ' ----------------------------------------------- reset the flag
            JumpingFromNEXT = False
        End If
        ' --------------------------------------------------- set the control variable
        SetNumericVariable(ControlVariableName, v)
    End Sub



    ' ======================================================================== NEW
    'Private Sub ExecuteFOR(ByVal ControlVariableName As String, _
    '                      ByVal vInitial As Double, _
    '                      ByVal vFinal As Double, _
    '                      ByVal vStep As Double, _
    '                      ByVal PC As Int32)

    '    Dim v As Double
    '    ' --------------------------------------------------- init the control variable value
    '    If Not JumpingFromNEXT Then
    '        v = vInitial
    '        ForNextStack.Push(PC)
    '    Else
    '        v = GetNumericVariable(ControlVariableName)
    '    End If

    '    ' --------------------------------------------------- 
    '    If JumpingFromNEXT Then

    '        vStep = Math.Sign(vFinal - vInitial)
    '        If vStep = 0 Then v = vFinal
    '        If vStep > 0 And v > vFinal Then v = vFinal
    '        If vStep < 0 And v < vFinal Then v = vFinal

    '        If v = vFinal Then
    '            GotoLine = JumpingFromNext_LineIndex + 1
    '            LineInExecution = JumpingFromNext_LineIndex
    '            ForNextStack.Pop()
    '        End If

    '        vStep = Math.Sign(vFinal - v)

    '        ' ----------------------------------------------- increase the control variable value
    '        v += vStep
    '        ' ----------------------------------------------- limit the value to vfinal
    '        If vStep > 0 Then
    '            If v > vFinal Then v = vFinal
    '        Else
    '            If v <= vFinal Then v = vFinal
    '        End If
    '        ' ----------------------------------------------- reset the flag
    '        JumpingFromNEXT = False
    '    End If
    '    ' --------------------------------------------------- set the control variable
    '    SetNumericVariable(ControlVariableName, v)
    'End Sub

    ' ===========================================================================================
    '  TRIM THE FOR-NEXT STACK WHEN JUMPING "NEXT" INSTRUCTIONS, WITH GOTO, IN FORWARD DIRECTION
    ' ===========================================================================================
    Private Sub TrimTheForNextStack_ByGoto(ByVal Goto_from As Int32, ByVal Goto_dest As Int32)
        For i As Int32 = Goto_from + 1 To Goto_dest - 1
            If RTB_Lines(i).Trim.ToLower.StartsWith("next") Then
                If ForNextStack.Count > 0 Then ForNextStack.Pop()
            End If
        Next
    End Sub

    ' ===========================================================================================
    '  Count "Next" statements before "Return" or the "End of file"
    '  and for each "Next" execute a ForNextStack POP
    ' ===========================================================================================
    Private Sub TrimTheForNextStack_ByReturn(ByVal Return_Line As Int32)
        Dim n As Int32 = 0
        For i As Int32 = Return_Line + 1 To RTB_Lines.Length - 1
            Dim s As String = RTB_Lines(i).Trim.ToLower
            If s.StartsWith("next") Then
                n += 1
            End If
            If s.StartsWith("for") Then
                n -= 1
            End If
            If s.StartsWith("label") Then
                Exit For
            End If
        Next
        If n > 0 Then
            For i As Int32 = 1 To n
                If ForNextStack.Count > 0 Then ForNextStack.Pop()
            Next
        End If
    End Sub

End Class