﻿
Public Module Module_PressKeys

    Private Declare Function keybd_event Lib "user32.dll" (ByVal bVk As Byte, _
                                                           ByVal bScan As Byte, _
                                                           ByVal dwFlags As Integer, _
                                                           ByVal dwExtraInfo As Integer) As UInteger

    Private Declare Function GetKeyboardLayout Lib "user32" Alias "GetKeyboardLayout" (ByVal idThread As Int32) As Int32

    Private Declare Function VkKeyScanEx Lib "user32" Alias "VkKeyScanExA" (ByVal ch As Char, ByVal dwhkl As Int32) As Short

    Private Declare Function mouse_event Lib "user32.dll" (ByVal dwFlags As UInteger, _
                                                       ByVal dx As Integer, _
                                                       ByVal dy As Integer, _
                                                       ByVal dwData As UInteger, _
                                                       ByVal dwExtraInfo As Integer) As UInteger

    Private Const MOUSEEVENTF_LEFTDOWN As Int32 = &H2
    Private Const MOUSEEVENTF_LEFTUP As Int32 = &H4
    Private Const MOUSEEVENTF_MIDDLEDOWN As Int32 = &H20
    Private Const MOUSEEVENTF_MIDDLEUP As Int32 = &H40
    Private Const MOUSEEVENTF_RIGHTDOWN As Int32 = &H8
    Private Const MOUSEEVENTF_RIGHTUP As Int32 = &H10

    Private Sub KeyDown(ByVal key As Byte)
        keybd_event(key, 0, 0, 0)
    End Sub

    Private Sub KeyUp(ByVal key As Byte)
        keybd_event(key, 0, 2, 0)
    End Sub

    Private Sub SendMouseEvent(ByVal key As Byte)
        Select Case key
            Case 250 : mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
            Case 251 : mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0)
            Case 252 : mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, 0, 0)
            Case 253 : mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, 0, 0)
            Case 254 : mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0)
            Case 255 : mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0)
        End Select
    End Sub

    Friend Function GetPressKeysNames() As String
        GetPressKeysNames = " SHIFT CTRL ALT WINDOWS " + _
                            "Tab Esc Space Enter Return Left Right Up Down " + _
                            "Backspace Pause CapsLock PageUp PageDown " + _
                            "End Home PrintScreen Insert Delete ScrollLock " + _
                            ": ; = , <  > _ . ? * + - / ~ ` [ { \ | ] } ' " + _
                            "a b c d e f g h i j k l m n o p q r s t u v w x y z " + _
                            "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z " + _
                            "0 1 2 3 4 5 6 7 8 9 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 " + _
                            "NumMul NumAdd NumSub NumDiv NumLock NumDelete " + _
                            "Num0 Num1 Num2 Num3 Num4 Num5 Num6 Num7 Num8 Num9 " + _
                            "LButtonDOWN LButtonUP MButtonDOWN MButtonUP RButtonDOWN RButtonUP "
    End Function

    Friend Function GetPressKeysNames_NoLetters() As String
        GetPressKeysNames_NoLetters = " SHIFT CTRL ALT WINDOWS " + _
                                      "Tab Esc Space Enter Return Left Right Up Down " + _
                                      "Backspace Pause CapsLock PageUp PageDown " + _
                                      "End Home PrintScreen Insert Delete ScrollLock " + _
                                      ": ; = , <  > _ . ? * + - / ~ ` [ { \ | ] } ' " + _
                                      "0 1 2 3 4 5 6 7 8 9 f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 " + _
                                      "NumMul NumAdd NumSub NumDiv NumLock NumDelete " + _
                                      "Num0 Num1 Num2 Num3 Num4 Num5 Num6 Num7 Num8 Num9 " + _
                                      "LButtonDOWN LButtonUP MButtonDOWN MButtonUP RButtonDOWN RButtonUP "
    End Function

    Private Function KeyNameToKeyCode(ByVal keyname As String) As Byte
        Select Case keyname.ToLower
            Case "tab" : Return 9
            Case "shift" : Return 16
            Case "ctrl" : Return 17
            Case "alt" : Return 18
            Case "windows" : Return 91

            Case "esc" : Return 27
            Case "space" : Return 32
            Case "enter" : Return 13
            Case "return" : Return 13
            Case "left" : Return 37
            Case "right" : Return 39
            Case "up" : Return 38
            Case "down" : Return 40
            Case "backspace" : Return 8
            Case "pause" : Return 19
            Case "capslock" : Return 20

            Case "pageup" : Return 33
            Case "pagedown" : Return 34

            Case "end" : Return 35
            Case "home" : Return 36
            Case "printscreen" : Return 44
            Case "insert" : Return 45
            Case "delete" : Return 46
            Case "scrolllock" : Return 145

            Case "f1" : Return 112
            Case "f2" : Return 113
            Case "f3" : Return 114
            Case "f4" : Return 115
            Case "f5" : Return 116
            Case "f6" : Return 117
            Case "f7" : Return 118
            Case "f8" : Return 119
            Case "f9" : Return 120
            Case "f10" : Return 121
            Case "f11" : Return 122
            Case "f12" : Return 123

            Case "nummul" : Return 106
            Case "numadd" : Return 107
            Case "numsub" : Return 109
            Case "numdiv" : Return 111
            Case "numlock" : Return 144
            Case "numdelete" : Return 110
            Case "num0" : Return 96
            Case "num1" : Return 97
            Case "num2" : Return 98
            Case "num3" : Return 99
            Case "num4" : Return 100
            Case "num5" : Return 101
            Case "num6" : Return 102
            Case "num7" : Return 103
            Case "num8" : Return 104
            Case "num9" : Return 105

            Case "lbuttondown" : Return 250
            Case "lbuttonup" : Return 251
            Case "mbuttondown" : Return 252
            Case "mbuttonup" : Return 253
            Case "rbuttondown" : Return 254
            Case "rbuttonup" : Return 255
        End Select
    End Function


    ' ======================================================================================================
    '  PRESS KEY
    ' ======================================================================================================
    Private Const VK_LCONTROL As Int32 = &HA2
    Private Const VK_LSHIFT As Int32 = &HA0
    Private Const VK_LMENU As Int32 = &HA4

    Friend Sub ExecutePressKeys(ByVal KeyNames As String)
        '
        Dim ModifierWINDOWS As Boolean = False
        Dim ModifierCTRL As Boolean = False
        Dim ModifierSHIFT As Boolean = False
        Dim ModifierALT As Boolean = False
        '
        KeyNames = KeyNames.Trim
        If KeyNames.ToLower.Contains("windows") Then
            ModifierWINDOWS = True
            KeyNames = Strings.Replace(KeyNames, "windows", "", , , CompareMethod.Text).Trim
        End If
        If KeyNames.ToLower.Contains("ctrl") Then
            ModifierCTRL = True
            KeyNames = Strings.Replace(KeyNames, "ctrl", "", , , CompareMethod.Text).Trim
        End If
        If KeyNames.ToLower.Contains("shift") Then
            ModifierSHIFT = True
            KeyNames = Strings.Replace(KeyNames, "shift", "", , , CompareMethod.Text).Trim
        End If
        If KeyNames.ToLower.Contains("alt") Then
            ModifierALT = True
            KeyNames = Strings.Replace(KeyNames, "alt", "", , , CompareMethod.Text).Trim
        End If
        '
        If ModifierWINDOWS Then KeyDown(91)

        If ModifierCTRL Then KeyDown(VK_LCONTROL)
        If ModifierSHIFT Then KeyDown(VK_LSHIFT)
        If ModifierALT Then KeyDown(VK_LMENU)
        '
        KeyNames = ReplaceMultipleSpacesAndTabAndTrim(KeyNames)
        Dim sa() As String = KeyNames.Split(" "c)
        For Each s As String In sa
            If s.Length = 1 Then
                PressVirtualKey(CChar(s))
            Else
                Dim kcode As Byte = KeyNameToKeyCode(s)
                If kcode < 250 Then
                    KeyDown(kcode)
                    KeyUp(kcode)
                Else
                    SendMouseEvent(kcode)
                End If
            End If
        Next
        '
        If ModifierWINDOWS Then KeyUp(91)
        If ModifierCTRL Then KeyUp(VK_LCONTROL)
        If ModifierSHIFT Then KeyUp(VK_LSHIFT)
        If ModifierALT Then KeyUp(VK_LMENU)
    End Sub

    ' ======================================================================================================
    '  PRESS VIRTUAL KEY
    ' ======================================================================================================
    Private Sub PressVirtualKey(ByVal ch As Char)
        '
        Dim keyboardLayout As Int32 = GetKeyboardLayout(0)
        Dim dw As Integer = VkKeyScanEx(ch, keyboardLayout)
        If dw < 0 Then Return
        '
        Dim kcode As Byte = CByte(dw And 255)
        Dim flags As Byte = CByte(dw >> 8)
        '
        Dim ModifierWINDOWS As Boolean = False
        Dim ModifierCTRL As Boolean = False
        Dim ModifierSHIFT As Boolean = False
        Dim ModifierALT As Boolean = False
        If (flags And 1) <> 0 Then ModifierSHIFT = True
        If (flags And 2) <> 0 Then ModifierCTRL = True
        If (flags And 4) <> 0 Then ModifierALT = True
        '
        If ModifierWINDOWS Then KeyDown(91)
        If ModifierCTRL Then KeyDown(VK_LCONTROL)
        If ModifierSHIFT Then KeyDown(VK_LSHIFT)
        If ModifierALT Then KeyDown(VK_LMENU)
        '
        KeyDown(kcode)
        KeyUp(kcode)
        '
        If ModifierWINDOWS Then KeyUp(91)
        If ModifierCTRL Then KeyUp(VK_LCONTROL)
        If ModifierSHIFT Then KeyUp(VK_LSHIFT)
        If ModifierALT Then KeyUp(VK_LMENU)
    End Sub

End Module
