﻿
Module Module_Variables

    ' =======================================================================================
    '  KEYWORDS
    ' =======================================================================================
    Friend ReservedKeywords As String ' Used to prevent variables with reserved names
    Friend Keywords() As String       ' Used to Replace keywords with the correct case
    Friend AllKeywords As String      ' Used by the suggestion functions
    Friend LoadKeywords As String     ' Used by the suggestion functions for the Load commend
    Friend FunctionNames() As String  ' Used by the evaluator suggestion function

    Friend Sub InitKeywords()

        ReservedKeywords = " slot slottext decodecommandslot decodexml formatxml" + _
                            " selectfile getfilenames getfoldernames fileexists apprunning gettextfile" + _
                            " getapplicationpath getfilepath getfilenamewithoutpath" + _
                            " sin cos asin acos tan atan atan2 sqrt abs sign" + _
                            " min max pow exp exp2 exp10 log log2 log10 limit limitreached" + _
                            " int round mid len trim left right" + _
                            " padleft padright str format ucase lcase wcase chars" + _
                            " replace removecomments stringcontains chr asc bin hex frombin fromhex val" + _
                            " crlf cr lf nbsp tab cls math_pi math_e infinity" + _
                            " now today date elapsedtime rnd filterlp filterhp" + _
                            " com_status com_received com_receiveuntil com_receivenchars com_portnames com_dsr com_cts" + _
                            " getseparatedstringcount getseparatedstring" + _
                            " mousex mousey mousexp mouseyp mousebuttons key" + _
                            " getcursorpixelcolor getpixelcolor getcolorred getcolorgreen getcolorblue" + _
                            " getcolorhue getcolorsaturation getcolorlightness getcolorindex" + _
                            " getsimplecolorname getnearestcolorname" + _
                            " print eventstop eventtimer event_externalcommands commandtext" + _
                            " if else endif and or xor not" + _
                            " disabled enabled color input message true false null" + _
                            " sleep reset recognize calibrate" + _
                            " seconds end exit text hide wait application" + _
                            " opentextbox closetextbox cleartextbox setcursorpos" + _
                            " select case caseelse endselect presskeys sendkeys" + _
                            " sleep space esc for next keypressed" + _
                            " home up down pageup pagedown beep button gosub goto" + _
                            " label load return save endSelect slot speed stop" + _
                            " variable varsfromfile window slots vars hide" + _
                            " openapps closeapps closeall windows controls " + _
                            " tts selectvoice setvolume setspeed speak speakwait stop pause resume " + _
                            " ttsvoices ttslanguage ttsready ttspaused ttsspeaking"

        Keywords = New String() {"Slot", "SlotText", "DecodeCommandSlot", "DecodeXML", "FormatXML", _
                                 "SelectFile", "GetFileNames", "GetFolderNames", "FileExists", "AppRunning", "GetTextFile", _
                                 "GetApplicationPath", "GetFilePath", "GetFileNameWithoutPath", _
                                 "Sin", "Cos", "Asin", "Acos", "Tan", "Atan", "Atan2", "Sqrt", "Abs", "Sign", _
                                 "Min", "Max", "Mod", "Pow", "Exp", "Exp2", "Exp10", "Log", "Log2", "Log10", _
                                 "Int", "Round", "Mid", "Len", "Trim", "Left", "Right", _
                                 "Num0", "Num1", "Num2", "Num3", "Num4", "Num5", "Num6", "Num7", "Num8", "Num9", _
                                 "PadLeft", "PadRight", "Str", "Format", "UCase", "LCase", "WCase", "Chars", _
                                 "Replace", "RemoveComments", "StringContains", "Chr", "Asc", "Bin", "Hex", "FromBin", "FromHex", "Val", _
                                 "CRLF", "CR", "LF", "NBSP", "TAB", "CLS", "Math_PI", "Math_E", "Infinity", _
                                 "Now", "Today", "Date", "ElapsedTime", "Rnd", "FilterLP", "FilterHP", _
                                 "COM_Status", "COM_Received", "COM_ReceiveUntil", "COM_ReceiveNChars", "COM_PortNames", "COM_Dsr", "COM_Cts", _
                                 "GetSeparatedStringCount", "GetSeparatedString", _
                                 "MouseX", "MouseY", "MouseXP", "MouseYP", "MouseButtons", "Key", _
                                 "GetCursorPixelColor", "GetPixelColor", "GetColorRed", "GetColorGreen", "GetColorBlue", _
                                 "GetColorHue", "GetColorSaturation", "GetColorLightness", "GetColorIndex", _
                                 "GetSimpleColorName", "GetNearestColorName", _
                                 "Limit", "LimitReached", "MediaPlaying", "MediaLength", "MediaPosition", _
                                 "Print", "EventStop", "EventTimer", "Event_ExternalCommands", "CommandText", _
                                 "If", "And", "Or", "Xor", "Not", _
                                 "Disabled", "Enabled", "Color", "Input", "Message", "True", "False", "Null", _
                                 "Sleep", "Reset", "Recognize", "Calibrate", _
                                 "Seconds", "End", "Exit", "Label", "Text", "Hide", "Wait", "Application", _
                                 "OpenTextBox", "CloseTextBox", "ClearTextBox", "SetCursorPos", _
                                 "Select", "Case", "CaseElse", "PressKeys", "SendKeys", "VarsFromFile", _
                                 "TTS", "SelectVoice", "SetVolume", "SetSpeed", "Speak", "SpeakWait", "Stop", "Pause", "Resume", _
                                 "TTSvoices", "TTSlanguage", "TTSready", "TTSpaused", "TTSspeaking"}

        AllKeywords = "Beep  Button  Controls  For  Next  Exit  GoSub  GoTo  If  Else  EndIf  " + _
                      "Key  Label  Load  Option  PressKeys  SendKeys  Print  Return  Save  Select  " + _
                      "Case  CaseElse  EndSelect  Slot  SlotText  Stop  End  TTS  Variable  VarsFromFile  Wait  Window"

        LoadKeywords = "Slots Vars Stop Pause Play Position Hide OpenApps CloseApps CloseAll Windows " + _
                       "or FILENAME(exe txt jpg jpeg png bmp avi wmv mpg mpeg mp4 m4v mov gif wav mp3 m4a mid midi etc..)  " + _
                       "or  HTTP  or  a generic string expression"

        FunctionNames = New String() {"Slot", "SlotText", "DecodeCommandSlot", "DecodeXML", "FormatXML", _
                                     "SelectFile", "GetFileNames", "GetFolderNames", "FileExists", "AppRunning", "GetTextFile", _
                                     "GetApplicationPath", "GetFilePath", "GetFileNameWithoutPath", _
                                     "Sin", "Cos", "Asin", "Acos", "Tan", "Atan", "Atan2", "Sqrt", "Abs", "Sign", _
                                     "Min", "Max", "Pow", "Exp", "Exp2", "Exp10", "Log", "Log2", "Log10", _
                                     "Int", "Round", "Mid", "Len", "Trim", "Left", "Right", _
                                     "PadLeft", "PadRight", "Str", "Format", "UCase", "LCase", "WCase", _
                                     "Chars", "Replace", "RemoveComments", "StringContains", "Chr", "Asc", "Bin", "Hex", "FromBin", "FromHex", "Val", _
                                     "CRLF", "CR", "LF", "NBSP", "TAB", "CLS", "Math_PI", "Math_E", "Infinity", _
                                     "Now", "Today", "Date", "ElapsedTime", "Rnd", "FilterLP", "FilterHP", _
                                     "COM_Status", "COM_Received", "COM_ReceiveUntil", "COM_ReceiveNChars", "COM_PortNames", "COM_Dsr", "COM_Cts", _
                                     "GetSeparatedStringCount", "GetSeparatedString", _
                                     "MouseX", "MouseY", "MouseXP", "MouseYP", "MouseButtons", "Key", _
                                     "GetCursorPixelColor", "GetPixelColor", "GetColorRed", "GetColorGreen", "GetColorBlue", _
                                     "GetColorHue", "GetColorSaturation", "GetColorLightness", "GetColorIndex", _
                                     "GetSimpleColorName", "GetNearestColorName", "CommandText", _
                                     "Limit", "LimitReached", "MediaPlaying", "MediaLength", "MediaPosition", _
                                     "And", "Or", "Xor", "Not", "True", "False", "Input", "Message", _
                                     "TTSvoices", "TTSlanguage", "TTSready", "TTSpaused", "TTSspeaking"}

        If SewFunctionsEnabled Then

            ReservedKeywords += " sewinit sewlimits sewto sewabort sewprogress"

            AllKeywords += "  -  SewInit  SewLimits  SewTo  SewAbort  SewProgress"

            Keywords = ConcatArrays(Keywords, New String() {"SewInit", "SewLimits", "SewTo", "SewAbort", "SewProgress"})

            FunctionNames = ConcatArrays(FunctionNames, New String() {"SewProgress"})

        End If

    End Sub


    ' =======================================================================================
    '  VARIABLES - SHORT VARS and USER DEFINED VARIABLES
    ' =======================================================================================
    Friend Const UserVariablesMinLength As Int32 = 2
    Friend NumericShortVars(99) As Double
    Friend StringShortVars(99) As String

    Structure NumericUserVariable
        Dim Name As String
        Dim Value As Double
        Dim Nline As Int32
    End Structure
    Structure StringUserVariable
        Dim Name As String
        Dim Value As String
        Dim Nline As Int32
    End Structure

    Private NumericUserVariableArray(-1) As NumericUserVariable
    Private StringUserVariableArray(-1) As StringUserVariable
    Private AllVariableNames(-1) As String

    Friend Function GetAllVariableNames() As String()
        Return AllVariableNames
    End Function

    ' =======================================================================================
    '  VARIABLES - REINIT USER DEFINED VARIABLES
    ' =======================================================================================
    Friend Sub ReinitUserVariables(Optional ByVal ResetAllValues As Boolean = False)
        ' ----------------------------------------------------- speed test 3 mS with 2000 lines
        'Dim sw As Stopwatch = New Stopwatch
        'sw.Start()
        ' ----------------------------------------------------- 
        RTB_Lines = Form1.RTB.Lines
        ' ----------------------------------------------------- save old values
        If Not ResetAllValues Then SaveOldVariableValues()
        ' ----------------------------------------------------- empty the arrays
        ReDim NumericUserVariableArray(-1)
        ReDim StringUserVariableArray(-1)
        ReDim AllVariableNames(-1)
        ' ----------------------------------------------------- scan all the lines
        For i As Int32 = 0 To RTB_Lines.Length - 1
            Dim line As String = RTB_Lines(i)
            If line.Trim.ToLower.StartsWith("variable") Then
                Dim sa() As String = Form1.RTB.Tokenize(line)
                If sa.Length = 3 Then
                    If TestUserVariableName(sa(2)) = "OK" Then
                        Select Case sa(1).ToLower
                            Case "numeric"
                                ReDim Preserve NumericUserVariableArray(NumericUserVariableArray.Length)
                                NumericUserVariableArray(NumericUserVariableArray.Length - 1).Name = sa(2)
                                'NumericUserVariableArray(NumericUserVariableArray.Length - 1).Value = 0
                                NumericUserVariableArray(NumericUserVariableArray.Length - 1).Nline = i
                            Case "string"
                                ReDim Preserve StringUserVariableArray(StringUserVariableArray.Length)
                                StringUserVariableArray(StringUserVariableArray.Length - 1).Name = sa(2)
                                StringUserVariableArray(StringUserVariableArray.Length - 1).Value = ""
                                StringUserVariableArray(StringUserVariableArray.Length - 1).Nline = i
                        End Select
                        ReDim Preserve AllVariableNames(AllVariableNames.Length)
                        AllVariableNames(AllVariableNames.Length - 1) = sa(2)
                    End If
                End If
                ' -------------------------------------------- Immediate vars initialization
                If sa.Length = 5 Then
                    If TestUserVariableName(sa(2)) = "OK" Then
                        Select Case sa(1).ToLower
                            Case "numeric"
                                ReDim Preserve NumericUserVariableArray(NumericUserVariableArray.Length)
                                NumericUserVariableArray(NumericUserVariableArray.Length - 1).Name = sa(2)
                                NumericUserVariableArray(NumericUserVariableArray.Length - 1).Nline = i
                                NumericUserVariableArray(NumericUserVariableArray.Length - 1).Value = EvalDouble(sa(4))
                            Case "string"
                                ReDim Preserve StringUserVariableArray(StringUserVariableArray.Length)
                                StringUserVariableArray(StringUserVariableArray.Length - 1).Name = sa(2)
                                StringUserVariableArray(StringUserVariableArray.Length - 1).Nline = i
                                StringUserVariableArray(StringUserVariableArray.Length - 1).Value = EvalString_AutoQuoting(sa(4))
                        End Select
                        ReDim Preserve AllVariableNames(AllVariableNames.Length)
                        AllVariableNames(AllVariableNames.Length - 1) = sa(2)
                    End If
                End If
            End If
        Next
        ' 
        If Not ResetAllValues Then RestoreVariableValues()
        '
        ' ------------------------------------------------------- RESET ALSO v1-v99 and s1-s99 VARIABLES
        If ResetAllValues Then
            For i As Int32 = 0 To 99
                NumericShortVars(i) = 0
                StringShortVars(i) = ""
            Next
        End If
        ' --------------------------------------------------------
        'Form1.Text = VariableNumericArray.Length.ToString + " " + VariableStringArray.Length.ToString
        'Form1.Text = sw.Elapsed.TotalMilliseconds.ToString
    End Sub



    Friend Function TestUserVariableName(ByVal name As String) As String
        ' --------------------------------- Identifiers may only begin with a letter or underscore
        Dim c As Char = name(0)
        If (c < "a" Or c > "z") And (c < "A" Or c > "Z") And c <> "_" Then
            Return "A variable name can not start with numbers or signs"
        End If
        ' --------------------------------- Identifiers may only contain letters, numbers and underscores
        For i As Int32 = 1 To name.Length - 1
            c = name(i)
            If (c < "a" Or c > "z") And (c < "A" Or c > "Z") And (c < "0" Or c > "9") And c <> "_" Then
                Return "A variable name can only contain letters, numbers and underscores"
            End If
        Next
        ' --------------------------------- test if it is a reserved word
        If ReservedKeywords.Contains(" " + name.ToLower + " ") Then
            Return "This variable name is a reserved word"
        End If
        ' --------------------------------- test if already exists
        If IsSomeVariable(name) Then
            Return "This variable name already exists"
        End If
        ' --------------------------------- test if too short
        If name.Length < UserVariablesMinLength Then
            Return "This variable name is too short"
        End If
        ' ---------------------------------
        Return "OK"
    End Function

    ' =======================================================================================
    '  SAVE AND RESTORE VAR VALUES - Before and after the "ReinitUserVariables"
    ' =======================================================================================
    Private OLD_NumericUserVariableArray(-1) As NumericUserVariable
    Private OLD_StringUserVariableArray(-1) As StringUserVariable
    Private Sub SaveOldVariableValues()
        OLD_NumericUserVariableArray = NumericUserVariableArray
        OLD_StringUserVariableArray = StringUserVariableArray
    End Sub
    Private Sub RestoreVariableValues()
        For i As Int32 = 0 To NumericUserVariableArray.Length - 1
            For Each oldv As NumericUserVariable In OLD_NumericUserVariableArray
                If NumericUserVariableArray(i).Name = oldv.Name Then
                    NumericUserVariableArray(i).Value = oldv.Value
                End If
            Next
        Next
        For i As Int32 = 0 To StringUserVariableArray.Length - 1
            For Each oldv As StringUserVariable In OLD_StringUserVariableArray
                If StringUserVariableArray(i).Name = oldv.Name Then
                    StringUserVariableArray(i).Value = oldv.Value
                End If
            Next
        Next
    End Sub

    ' =======================================================================================
    '  VARS FROM FILE
    ' =======================================================================================
    Friend Function VarsFromFile(ByVal f As String) As String
        VarsFromFile = ""
        Dim sa2() As String
        Dim sa() As String = IO.File.ReadAllLines(f)
        For Each s As String In sa
            RemoveComments(s)
            s = ReplaceMultipleSpacesAndTabAndTrim(s)
            If s <> "" Then
                sa2 = s.Split("="c)
                If sa2.Length = 2 Then
                    If IsSomeVariable(sa2(0).Trim) Then
                        SetVariable(sa2(0).Trim, sa2(1).Trim.Replace("""", ""))
                    Else
                        VarsFromFile += "ERROR - Unknown variable """ + sa2(0).Trim + """" + vbCrLf
                    End If
                Else
                    VarsFromFile += "ERROR - Unknown command """ + sa2(0).Trim + """" + vbCrLf
                End If
            End If
        Next
    End Function


    ' =======================================================================================
    '  TEST VARIABLES
    ' =======================================================================================
    Friend Function IsSomeVariable(ByVal name As String) As Boolean
        If name Is Nothing Then Return False
        If IsNumericUserVariable(name) Then Return True
        If IsStringUserVariable(name) Then Return True
        If IsNumericShortVariable(name) Then Return True
        If IsStringShortVariable(name) Then Return True
        Return False
    End Function
    Friend Function IsNumericVariable(ByVal name As String) As Boolean
        If name Is Nothing Then Return False
        If IsNumericUserVariable(name) Then Return True
        If IsNumericShortVariable(name) Then Return True
        Return False
    End Function
    Friend Function IsStringVariable(ByVal name As String) As Boolean
        If name Is Nothing Then Return False
        If IsStringUserVariable(name) Then Return True
        If IsStringShortVariable(name) Then Return True
        Return False
    End Function

    Friend Function IsNumericUserVariable(ByVal name As String) As Boolean
        For i As Int32 = 0 To NumericUserVariableArray.Length - 1
            If name.ToLower = NumericUserVariableArray(i).Name.ToLower Then Return True
        Next
        Return False
    End Function
    Friend Function IsStringUserVariable(ByVal name As String) As Boolean
        For i As Int32 = 0 To StringUserVariableArray.Length - 1
            If name.ToLower = StringUserVariableArray(i).Name.ToLower Then Return True
        Next
        Return False
    End Function

    Friend Function IsNumericUserVariable(ByVal name As String, ByVal line As Int32) As Boolean
        For i As Int32 = 0 To NumericUserVariableArray.Length - 1
            If name.ToLower = NumericUserVariableArray(i).Name.ToLower And line = NumericUserVariableArray(i).Nline Then Return True
        Next
        Return False
    End Function
    Friend Function IsStringUserVariable(ByVal name As String, ByVal line As Int32) As Boolean
        For i As Int32 = 0 To StringUserVariableArray.Length - 1
            If name.ToLower = StringUserVariableArray(i).Name.ToLower And line = StringUserVariableArray(i).Nline Then Return True
        Next
        Return False
    End Function

    Friend Function TheLineContainsSomeUserVariable(ByVal l As String) As Boolean
        l = StringSpacedAroundOperators(l)
        Dim sa() As String = l.Split(" "c)
        For Each s As String In sa
            If IsNumericUserVariable(s) Then Return True
            If IsStringUserVariable(s) Then Return True
        Next
        Return False
    End Function

    ' =======================================================================================
    '  TEST FOR SHORT VARIABLES
    ' =======================================================================================
    Friend Function IsNumericShortVariable(ByVal name As String) As Boolean
        If name.Length < 2 Then Return False
        name = name.ToLower
        If name(0) <> "v" Then Return False
        Dim n As Int32 = CInt(Val(name.Substring(1)))
        If n < 1 Or n > 99 Then Return False
        Return True
    End Function
    Friend Function IsStringShortVariable(ByVal name As String) As Boolean
        If name.Length < 2 Then Return False
        name = name.ToLower
        If name(0) <> "s" Then Return False
        Dim n As Int32 = CInt(Val(name.Substring(1)))
        If n < 1 Or n > 99 Then Return False
        Return True
    End Function

    ' =======================================================================================
    '  SET and GET VARIABLES
    ' =======================================================================================
    Friend Sub SetVariable(ByVal name As String, ByVal value As String)
        If IsNumericUserVariable(name) Then SetNumericUserVariable(name, Val(value)) : Return
        If IsStringUserVariable(name) Then SetStringUserVariable(name, value) : Return
        If IsNumericShortVariable(name) Then SetNumericShortVar(name, Val(value)) : Return
        If IsStringShortVariable(name) Then SetStringShortVar(name, value) : Return
    End Sub

    Friend Sub SetNumericVariable(ByVal name As String, ByVal value As Double)
        If IsNumericUserVariable(name) Then SetNumericUserVariable(name, value) : Return
        If IsNumericShortVariable(name) Then SetNumericShortVar(name, value) : Return
    End Sub

    Friend Function GetNumericVariable(ByVal name As String) As Double
        If IsNumericUserVariable(name) Then Return GetNumericUserVariable(name)
        If IsNumericShortVariable(name) Then Return GetNumericShortVariable(name)
    End Function

    Friend Function GetStringVariable(ByVal name As String) As String
        If IsStringUserVariable(name) Then Return GetStringUserVariable(name)
        If IsStringShortVariable(name) Then Return GetStringShortVariable(name)
        Return ""
    End Function

    Friend Sub GetVariable(ByVal name As String, ByRef value As Object)
        If IsNumericUserVariable(name) Then
            value = GetNumericUserVariable(name)
        ElseIf IsStringUserVariable(name) Then
            value = GetStringUserVariable(name)
        ElseIf IsNumericShortVariable(name) Then
            value = GetNumericShortVariable(name)
        ElseIf IsStringShortVariable(name) Then
            value = GetStringShortVariable(name)
        End If
    End Sub

    Friend Sub SetNumericShortVar(ByVal name As String, ByVal value As Double)
        Dim n As Double = Val(name.Substring(1))
        If n > 0 And n < 100 Then
            NumericShortVars(CInt(n)) = value
        End If
    End Sub

    Friend Sub SetStringShortVar(ByVal name As String, ByVal value As String)
        Dim n As Double = Val(name.Substring(1))
        If n > 0 And n < 100 Then
            StringShortVars(CInt(n)) = value
        End If
    End Sub

    Friend Function GetNumericShortVariable(ByVal name As String) As Double
        Dim n As Double = Val(name.Substring(1))
        If n > 0 And n < 100 Then
            Return NumericShortVars(CInt(n))
        End If
    End Function

    Friend Function GetStringShortVariable(ByVal name As String) As String
        Dim n As Double = Val(name.Substring(1))
        If n > 0 And n < 100 Then
            Return StringShortVars(CInt(n))
        End If
        Return ""
    End Function

    ' =======================================================================================
    '  SET and GET - USER DEFINED VARIABLES
    ' =======================================================================================
    Friend Sub SetNumericUserVariable(ByVal name As String, ByVal value As Double)
        For i As Int32 = 0 To NumericUserVariableArray.Length - 1
            If name.ToLower = NumericUserVariableArray(i).Name.ToLower Then
                NumericUserVariableArray(i).Value = value
            End If
        Next
    End Sub
    Friend Sub SetStringUserVariable(ByVal name As String, ByVal value As String)
        For i As Int32 = 0 To StringUserVariableArray.Length - 1
            If name.ToLower = StringUserVariableArray(i).Name.ToLower Then
                StringUserVariableArray(i).Value = value
            End If
        Next
    End Sub

    Friend Function GetNumericUserVariable(ByVal name As String) As Double
        For i As Int32 = 0 To NumericUserVariableArray.Length - 1
            If name.ToLower = NumericUserVariableArray(i).Name.ToLower Then
                Return NumericUserVariableArray(i).Value
            End If
        Next
        Return 0
    End Function
    Friend Function GetStringUserVariable(ByVal name As String) As String
        For i As Int32 = 0 To StringUserVariableArray.Length - 1
            If name.ToLower = StringUserVariableArray(i).Name.ToLower Then
                Return StringUserVariableArray(i).Value
            End If
        Next
        Return ""
    End Function

    Friend Function GetVariablesStartingWith(ByVal initial As String) As String
        Dim s As String = ""
        For Each v As NumericUserVariable In NumericUserVariableArray
            If v.Name.ToLower.StartsWith(initial) Then
                s += v.Name + " / "
            End If
        Next
        For Each v As StringUserVariable In StringUserVariableArray
            If v.Name.ToLower.StartsWith(initial) Then
                s += v.Name + " / "
            End If
        Next
        If initial = "v" Then
            s += "v1..v99 / "
        End If
        If initial = "s" Then
            s += "s1..s99 / "
        End If
        If s.EndsWith(" / ") Then s = s.Remove(s.Length - 3)
        Return s
    End Function


    ' =======================================================================================
    '  LABEL NAMES
    ' =======================================================================================
    Friend LabelNames(-1) As String
    Friend LabelLineNumbers(-1) As Int32

    Friend Sub ReinitLabelNames()
        ' ----------------------------------------------------- speed test 3 mS with 2000 lines
        'Dim sw As Stopwatch = New Stopwatch
        'sw.Start()
        ' ----------------------------------------------------- 
        RTB_Lines = Form1.RTB.Lines
        ' ----------------------------------------------------- empty the array
        ReDim LabelNames(-1)
        ReDim LabelLineNumbers(-1)
        ' ----------------------------------------------------- scan all the lines
        For i As Int32 = 0 To RTB_Lines.Length - 1
            Dim line As String = RTB_Lines(i).Trim
            If line.ToLower.StartsWith("label") Then
                RemoveComments(line)
                If line.Length > 6 Then
                    ReDim Preserve LabelNames(LabelNames.Length)
                    LabelNames(LabelNames.Length - 1) = line.Substring(6).Replace("""", "").Trim
                    ReDim Preserve LabelLineNumbers(LabelLineNumbers.Length)
                    LabelLineNumbers(LabelLineNumbers.Length - 1) = i
                End If
            End If
        Next
        '
        'Form1.Text = AllLabelNames.Length.ToString
        'Form1.Text = sw.Elapsed.TotalMilliseconds.ToString
    End Sub


    Friend Function GetLabelNamesStartingWith(ByVal str As String) As String
        Dim s As String = ""
        str = str.ToLower
        For Each l As String In LabelNames
            If l.ToLower.StartsWith(str) Then
                s += l + " / "
            End If
        Next
        Return s
    End Function

    'Friend Function GetLabelNamesStartingWith_AndRemovingParams(ByVal str As String) As String
    '    Dim s As String = ""
    '    str = str.ToLower
    '    Dim i As Int32 = str.IndexOf("("c)
    '    str = str.Remove(i)
    '    For Each l As String In LabelNames
    '        If l.ToLower.StartsWith(str) Then
    '            s += l + " / "
    '        End If
    '    Next
    '    Return s
    'End Function

    Friend Function GetLabelLine(ByVal str As String) As Int32
        str = str.ToLower
        For i As Int32 = 0 To LabelNames.Length - 1
            If LabelNames(i).ToLower = str Then
                Return LabelLineNumbers(i)
            End If
        Next
        Return -1
    End Function



End Module
