﻿Imports System.Runtime.InteropServices

Module Module_WindowsShutDown
    ' ------------------------------------------------------------- Constants
    Const SE_PRIVILEGE_ENABLED As Integer = &H2
    Const TOKEN_QUERY As Integer = &H8
    Const TOKEN_ADJUST_PRIVILEGES As Integer = &H20
    Const SE_SHUTDOWN_NAME As String = "SeShutdownPrivilege"
    ' ------------------------------------------------------------- Exit Windows Constants
    Const EWX_LOGOFF As Integer = &H0
    Const EWX_SHUTDOWN As Integer = &H1
    Const EWX_REBOOT As Integer = &H2
    Const EWX_FORCE As Integer = &H4
    Const EWX_POWEROFF As Integer = &H8
    Const EWX_FORCEIFHUNG As Integer = &H10

    <StructLayout(LayoutKind.Sequential, Pack:=1)> _
    Private Structure TokPriv1Luid
        Public Count As Integer
        Public Luid As Long
        Public Attr As Integer
    End Structure

    <DllImport("kernel32.dll", ExactSpelling:=True)> _
    Private Function GetCurrentProcess() As IntPtr
    End Function

    <DllImport("advapi32.dll", SetLastError:=True)> _
    Private Function OpenProcessToken(ByVal h As IntPtr, ByVal acc As Integer, ByRef phtok As IntPtr) As Boolean
    End Function

    <DllImport("advapi32.dll", SetLastError:=True)> _
    Private Function LookupPrivilegeValue(ByVal host As String, ByVal name As String, ByRef pluid As Long) As Boolean
    End Function

    <DllImport("advapi32.dll", ExactSpelling:=True, SetLastError:=True)> _
    Private Function AdjustTokenPrivileges(ByVal htok As IntPtr, ByVal disall As Boolean, ByRef newst As TokPriv1Luid, ByVal len As Integer, ByVal prev As IntPtr, ByVal relen As IntPtr) As Boolean
    End Function

    <DllImport("user32.dll", ExactSpelling:=True, SetLastError:=True)> _
    Private Function ExitWindowsEx(ByVal flg As Integer, ByVal rea As Integer) As Boolean
    End Function


    Private Sub DoExitWindows(ByVal flg As Integer)
        Dim tp As TokPriv1Luid
        Dim hproc As IntPtr = GetCurrentProcess()
        Dim htok As IntPtr = IntPtr.Zero
        ' --------------------------------------------------------------------- Get a token for this process. 
        OpenProcessToken(hproc, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, htok)
        tp.Count = 1
        tp.Luid = 0
        tp.Attr = SE_PRIVILEGE_ENABLED
        ' --------------------------------------------------------------------- Get the LUID for the shutdown privilege.
        LookupPrivilegeValue(Nothing, SE_SHUTDOWN_NAME, tp.Luid)
        ' --------------------------------------------------------------------- Get the shutdown privilege for this process.
        AdjustTokenPrivileges(htok, False, tp, 0, IntPtr.Zero, IntPtr.Zero)
        ' --------------------------------------------------------------------- Exit Windows
        ExitWindowsEx(flg, 0)
    End Sub


    ' ------------------------------------------------------------- Shutdown
    'DoExitWindows(EWX_SHUTDOWN)
    ' ------------------------------------------------------------- Restart
    'DoExitWindows(EWX_REBOOT Or EWX_FORCE)
    ' ------------------------------------------------------------- Log off
    'DoExitWindows(EWX_LOGOFF)

    Friend Sub ForceWindowsShutDownAndPowerOff()
        DoExitWindows(EWX_SHUTDOWN Or EWX_FORCE Or EWX_FORCEIFHUNG)
    End Sub

End Module

